package com.cnd3b.common.actionscore;

import com.cnd3b.common.Controller;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.db.DBConnect;

/**
 * жϵͳ
 */
public class AgentActionScore extends ActionScore {
    /**
     * ̹캯
     *
     * @param siteid    վ
     * @param tagentsid
     * @param createby
     */
    public AgentActionScore(String siteid, String tagentsid, long userid, String createby, ActionScore.fsourcetype fsourcetype, long fsourceid, String fnotes) {
        this.siteid = siteid;
        this.createby = createby;
        this.tagentsid = tagentsid;
        this.userid = userid;
        this.fusertype = "";
        this.fsourcetype = fsourcetype;
        this.fsourceid = fsourceid;
        this.fnotes = fnotes;
    }

    /**
     * ̹캯1
     */
    public AgentActionScore(Controller controller, ActionScore.fsourcetype fsourcetype, long fsourceid, String fnotes) {
        this.siteid = controller.siteid;
        this.createby = controller.username;
        this.tagentsid = controller.tagentsid;
        this.userid = controller.userid;
        this.fusertype = "";
        this.fsourcetype = fsourcetype;
        this.fsourceid = fsourceid;
        this.fnotes = fnotes;
    }


    /**
     * жֵ
     */
    public void add() {
        synchronized (AgentActionScore.class) {
            super.actionScore_Add(addValidate());
        }
    }

    /**
     * Ҫ֤жֵ֤,ж÷
     *
     * @return
     */
    private int addValidate() {

        boolean isaddscore = true;
        switch (fsourcetype) {
            case ÿǩ: {
                /**
                 * ܵظǩظǷ
                 */
                SQLFactory sqlFactory = new SQLFactory(this, "_ǩѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            case ͻ¼: {
                /**
                 * ͬһݲظ¼룬迼ظ¼
                 */
                isaddscore = true;
                break;
            }
            case ¼: {
                /**
                 * ͬһݲظ¼룬迼ظ¼
                 */
                isaddscore = true;
                break;
            }
            case ¼: {
                /**
                 * ͬһݲظ¼룬迼ظ¼
                 */
                isaddscore = true;
                break;
            }
            case ¼¼: {
                isaddscore = true;
                break;
            }
            case ǿ: {
                SQLFactory sqlFactory = new SQLFactory(this, "_ǿѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                sqlFactory.addParameter("fsourceid", fsourceid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            case Ķͨ: {
                /**
                 * ظĶͨ棬ظǷ
                 */
                SQLFactory sqlFactory = new SQLFactory(this, "_ͨĶѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                sqlFactory.addParameter("fsourceid", fsourceid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            case ͨ: {
                /**
                 * ظͨ棬ظǷ
                 */
                SQLFactory sqlFactory = new SQLFactory(this, "_ֲͨѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                sqlFactory.addParameter("fsourceid", fsourceid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            case ͨ渽: {
                /**
                 * ظͨ渽ظǷ
                 */
                SQLFactory sqlFactory = new SQLFactory(this, "_ͨ渽ѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                sqlFactory.addParameter("fsourceid", fsourceid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            case Ӫǿ: {
                /**
                 * ظͨ渽ظǷ
                 */
                SQLFactory sqlFactory = new SQLFactory(this, "_ǿزĲѯ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                sqlFactory.addParameter("fsourceid", fsourceid);
                Rows rows = new DBConnect().runSqlQuery(sqlFactory.getSQL());
                isaddscore = rows.isEmpty();
                break;
            }
            default:break;
        }
        if (isaddscore) {
            return getScore();
        } else {
            return 0;
        }
    }


}
