package com.cnd3b.restcontroller.enterprise.agentclient.mainpage.action.receptioninput;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Date;

public class receptioninput extends Controller {
    public receptioninput(JSONObject content) {
        super(content);
    }


    /**
     * ̽Ӵ¼бѯ
     *
     * @return
     */
    public String query_receptionList() {
        /**
         *
         */
        String[] sortfield = {"t1.changedate"};
        String sort = getSort(sortfield, "t1.changedate");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");

            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fcommunity like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("begdate") && !"".equals(whereObject.getString("begdate"))) {
                where.append(" and convert(varchar(10),t1.changedate,120)>=").append("'").append(whereObject.getString("begdate")).append("'");
            }
            if (whereObject.containsKey("enddate") && !"".equals(whereObject.getString("enddate"))) {
                where.append(" and convert(varchar(10),t1.changedate,120)<=").append("'").append(whereObject.getString("enddate")).append("'");
            }
            if (!fisadministrator) {
                where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "̽Ӵ¼бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).addAppHelpNotes(getAppHelpNotes("Ӵϵͳ")).setFinalDo(0, 1);
    }


    /**
     * ̽Ӵ¼ѯ
     *
     * @return
     */
    public String query_receptionMain() {
        SQLFactory sqlFactory = new SQLFactory(this, "̽Ӵ¼ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcustomer_receptid", content.getString("tcustomer_receptid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("datalog", getDataLog("tcustomer_reception", row.getString("tcustomer_receptid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ̽Ӵ¼޸
     *
     * @return
     */
    public String receptionInsertOrModify() throws D3bException, P2Exception {
        long tcustomer_receptid = content.getLongValue("tcustomer_receptid");//Ӵ¼IDʱĬϴ0
        String fname = content.getString("fname", "tcustomer.fname", "ͻ");//˿
        String fphonenumber = content.getString("fphonenumber", "tcustomer.fphonenumber", "ֻ");//ֻ
        String fchannel = content.getString("fchannel");//Դ
        String fcommunity = content.getString("fcommunity", "tcustomer.fcommunity", "С");//С
        String fnumber = content.getString("fnumber", "tcustomer.fnumber", "/Ԫ/");///Ԫ/
        String frenovationplandate = content.getString("frenovationplandate");//ƻװʱ
        String tstoreid = content.getString("tstoreid");//ŵID
        Date fdate = content.getDate("fdate");//Ӵ

        String freception_address = content.getString("freception_address");//Ӵص
        String fcustaction = content.getString("fcustaction");//ͻ
        String fnotes = content.getString("fnotes", "tcustomer_reception.fnotes", "Ӵ");//Ӵ

        PaoSetRemote tcustomerSet = getP2ServerSystemPaoSet("tcustomer", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and fphonenumber='" + fphonenumber + "'");
        PaoRemote tcustomer = null;
        if (tcustomerSet.isEmpty()) {
            tcustomer = tcustomerSet.addAtEnd();
            tcustomer.setValue("fchannel", fchannel, 11L);//Դ
            tcustomer.setValue("siteid", siteid, 11L);//ҵID
            tcustomer.setValue("tagentsid", tagentsid, 11L);//ID
            tcustomer.setValue("createby", username, 11L);//¼
            tcustomer.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tcustomer = tcustomerSet.getPao(0);
        }
        tcustomer.setValue("fname", fname, 11L);
        tcustomer.setValue("fphonenumber", fphonenumber, 11L);//ͻֻ
        tcustomer.setValue("fcommunity", fcommunity, 11L);//С
        tcustomer.setValue("fnumber", fnumber, 11L);///Ԫ/
        tcustomer.setValue("frenovationplandate", frenovationplandate, 11L);//ƻװʱ
        tcustomer.setValue("tstoreid", tstoreid, 11L);//ŵID

        tcustomer.setValue("changeby", username, 11L);//޸
        tcustomer.setValue("changedate", sysdate, 11L);//޸ʱ

        long tcustomerid = tcustomer.getUniqueIDValue();
        /**
         * ѯۼ¼粻ڣۼ¼
         */
        PaoSetRemote tcustomer_receptionSet = tcustomer.getPaoSet("$tcustomer_reception", "tcustomer_reception", "siteid=:siteid and tagentsid=:tagentsid and tcustomer_receptid='" + tcustomer_receptid + "'");
        PaoRemote tcustomer_reception = null;
        if (tcustomer_receptid <= 0 || tcustomer_receptionSet.isEmpty()) {
            tcustomer_reception = tcustomer_receptionSet.addAtEnd();
            tcustomer_reception.setValue("fwaiter", username, 11L);//ӴԱ
            tcustomer_reception.setValue("tenterprise_userid", userid, 11L);//˺ID
            tcustomer_reception.setValue("siteid", siteid, 11L);//ҵID
            tcustomer_reception.setValue("tagentsid", tagentsid, 11L);//ID
            tcustomer_reception.setValue("ftype", "Ӵ", 11L);//¼
            tcustomer_reception.setValue("createby", username, 11L);//¼
            tcustomer_reception.setValue("createdate", sysdate, 11L);//¼ʱ

            tcustomer.setValue("freceptiontimes", tcustomer.getInt("freceptiontimes") + 1, 11L);

            addActionScore(ActionScore.fsourcetype.ͻ¼, tcustomer_reception.getUniqueIDValue(), "ͻ¼");
        } else {
            tcustomer_reception = tcustomer_receptionSet.getPao(0);
        }

        tcustomer_reception.setValue("tcustomerid", tcustomerid, 11L);//ͻID
        tcustomer_reception.setValue("fname", fname, 11L);//˿
        tcustomer_reception.setValue("fphonenumber", fphonenumber, 11L);//ͻֻ
        tcustomer_reception.setValue("fchannel", fchannel, 11L);//Դ
        tcustomer_reception.setValue("fcommunity", fcommunity, 11L);//С
        tcustomer_reception.setValue("fnumber", fnumber, 11L);///Ԫ/
        tcustomer_reception.setValue("frenovationplandate", frenovationplandate, 11L);//ƻװʱ
        tcustomer_reception.setValue("fdate", fdate, 11L);//Ӵ
        tcustomer_reception.setValue("freception_address", freception_address, 11L);//Ӵص
        tcustomer_reception.setValue("fcustaction", fcustaction, 11L);//ͻ
        tcustomer_reception.setValue("fnotes", fnotes, 11L);//Ӵ
        tcustomer_reception.setValue("fstatus", "", 11L);//Ӵ¼״̬

        tcustomer_reception.setValue("tstoreid", tstoreid, 11L);//ŵID
        tcustomer_reception.setValue("changeby", username, 11L);//޸
        tcustomer_reception.setValue("changedate", sysdate, 11L);//޸ʱ

        content.put("tcustomer_receptid", tcustomer_reception.getString("tcustomer_receptid"));

        saveDataLog(tcustomer_reception);
        tcustomerSet.save();
        tcustomerSet.close();

        return query_receptionMain();
    }


    /**
     * ̽Ӵ¼ɾ
     *
     * @return
     */
    public String receptionDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "̽Ӵ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcustomer_receptid", content.getString("tcustomer_receptid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());

        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * Դѡ
     *
     * @return
     */
    public String selectChannel() {
        SQLFactory sqlFactory = new SQLFactory(this, "Դѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        String result = rows.toJsonArray("fchannel").toString();
        DataPool.put(content.toString(), result);
        return result;
    }


    /**
     * Ӵŵѡ
     *
     * @return
     */
    public String selectStore() {
        SQLFactory sqlFactory = new SQLFactory(this, "Ӵŵѡ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ۶ѡ
     *
     * @return
     */
    public String selectCustaction() {
        SQLFactory sqlFactory = new SQLFactory(this, "۶ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        String result = rows.toJsonArray("fcustaction").toString();
        DataPool.put(content.toString(), result);
        return result;
    }

    /**
     * ֻƥͻ
     *
     * @return
     */
    public String queryCustomerByPhoneNumber() {
        if (content.getString("fphonenumber").length() >= 7) {
            SQLFactory sqlFactory = new SQLFactory(this, "ֻŲѯͻ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tagentsid", tagentsid);
            sqlFactory.addParameter("fphonenumber", content.getString("fphonenumber") + "%");
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            return getSucReturnObject().setData(rows).saveToDataPool().toString();
        } else {
            return getSucReturnObject().setData(new Rows()).toString();
        }
    }

}
