package com.cnd3b.restcontroller.enterprise.agentclient.usercenter.storemsg;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class storemsg extends Controller {
    public storemsg(JSONObject content) {
        super(content);
    }

    /**
     * ŵбѯ
     *
     * @return
     */
    public String query_storeList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵбѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ŵѯ
     *
     * @return
     */
    public String query_storeMain() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tstoreid", content.getString("tstoreid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ŵ޸
     *
     * @return
     */
    public String storeInsertOrModify() throws D3bException, P2Exception {
        long tstoreid = content.getLongValue("tstoreid");//ŵIDʱĬϴ0
        String fstorenum = content.getString("fstorenum", "tstore.fstorenum", "ŵ");//ŵ
        String fstorename = content.getString("fstorename", "tstore.fstorename", "ŵ");//ŵ
        double farea = content.getDoubleValue("farea");//ŵ
        String fstoretype = content.getString("fstoretype");//ŵ
        String fmarket = content.getString("fmarket");//
        String fstartdate = content.getString("fstartdate");//
        String fstatus = content.getString("fstatus");//ŵ״̬
        String fprovince = content.getString("fprovince");//ʡ
        String fcity = content.getString("fcity");//
        String fcounty = content.getString("fcounty");//
        String faddress = content.getString("faddress", "tstore.faddress", "ϸַ");//ŵַ
        String fcontact = content.getString("fcontact", "tstore.fcontact", "ŵ긺");//ϵ
        String fphonenumber = content.getString("fphonenumber", "tstore.fphonenumber", "ֻ");//ϵʽ
        String femail = content.getString("femail", "tstore.femail", "");//
        String fwechatno = content.getString("fwechatno", "tstore.fwechatno", "΢");//΢ź

        PaoSetRemote tstoreSet = getP2ServerSystemPaoSet("tstore", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tstoreid='" + tstoreid + "'");
        PaoRemote tstore = null;
        if (tstoreid <= 0 || tstoreSet.isEmpty()) {
            tstore = tstoreSet.addAtEnd();
            tstore.setValue("siteid", siteid, 11L);//ҵID
            tstore.setValue("tagentsid", tagentsid, 11L);//ID
            tstore.setValue("createby", username, 11L);//¼
            tstore.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tstore = tstoreSet.getPao(0);
        }
        tstore.setValue("fstorenum", fstorenum, 11L);//ŵ
        tstore.setValue("fstorename", fstorename, 11L);//ŵ
        tstore.setValue("farea", farea, 11L);//ŵ
        tstore.setValue("fstoretype", fstoretype, 11L);//ŵ
        tstore.setValue("fmarket", fmarket, 11L);//
        tstore.setValue("fstartdate", fstartdate, 11L);//
        tstore.setValue("fstatus", fstatus, 11L);//ŵ״̬
        tstore.setValue("fprovince", fprovince, 11L);//ʡ
        tstore.setValue("fcity", fcity, 11L);//
        tstore.setValue("fcounty", fcounty, 11L);//
        tstore.setValue("faddress", faddress, 11L);//ŵַ
        tstore.setValue("fcontact", fcontact, 11L);//ϵ
        tstore.setValue("fphonenumber", fphonenumber, 11L);//ϵʽ
        tstore.setValue("femail", femail, 11L);//
        tstore.setValue("fwechatno", fwechatno, 11L);//΢

        tstore.setValue("changeby", username, 11L);//޸
        tstore.setValue("changedate", sysdate, 11L);//޸ʱ
        content.put("tstoreid", tstore.getUniqueIDValue());
        saveDataLog(tstore);
        tstoreSet.save();
        
        return query_storeMain();
    }


    /**
     * ŵɾ
     *
     * @return
     */
    public String storeDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tstoreid", content.getString("tstoreid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * бѯ
     *
     * @return
     */
    public String query_marketList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ŵѡ
     *
     * @return
     */
    public String query_storetypeList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ŵ״̬ѡ
     *
     * @return
     */
    public String query_storestatusList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵ״̬ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

}
