package com.cnd3b.restcontroller.enterprise.agentwebclient.mainpage.action.saleeventinput;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Date;

public class saleeventinput extends Controller {
    public saleeventinput(JSONObject content) {
        super(content);
    }


    /**
     * Ӫ¼бѯ
     *
     * @return
     */
    public String query_saleEventList() {
        /**
         *
         */
        String[] sortfield = {"t1.changedate"};
        String sort = getSort(sortfield, "t1.changedate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fsaleevent like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("begdate") && !"".equals(whereObject.getString("begdate"))) {
                where.append(" and convert(varchar(10),t1.changedate,120)>=").append("'").append(whereObject.getString("begdate")).append("'");
            }
            if (whereObject.containsKey("enddate") && !"".equals(whereObject.getString("enddate"))) {
                where.append(" and convert(varchar(10),t1.changedate,120)<=").append("'").append(whereObject.getString("enddate")).append("'");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫ¼бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * Ӫ¼ѯ
     *
     * @return
     */
    public String query_saleEventMain() {
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫ¼ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tsaleeventid", content.getString("tsaleeventid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("datalog", getDataLog("tsaleevent", row.getString("tsaleeventid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ӫ¼޸
     *
     * @return
     */
    public String saleEventInsertOrModify() throws D3bException, P2Exception {
        long tsaleeventid = content.getLongValue("tsaleeventid");//Ӫ¼IDʱĬϴ0
        String fsaleevent = content.getString("fsaleevent", "tsaleevent.fsaleevent", "¼");//Ӫ¼
        Date fbegdate = content.getDate("fbegdate");//ִ
        Date fenddate = content.getDate("fenddate");//ʱ

        PaoSetRemote tsaleeventSet = getP2ServerSystemPaoSet("tsaleevent", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsaleeventid='" + tsaleeventid + "'");
        PaoRemote tsaleevent = null;
        if (tsaleeventid <= 0 || tsaleeventSet.isEmpty()) {
            tsaleevent = tsaleeventSet.addAtEnd();
            tsaleevent.setValue("siteid", siteid, 11L);//ҵID
            tsaleevent.setValue("tagentsid", tagentsid, 11L);//ID
            tsaleevent.setValue("createby", username, 11L);//¼
            tsaleevent.setValue("createdate", sysdate, 11L);//¼ʱ
            addActionScore(ActionScore.fsourcetype.¼¼, tsaleevent.getUniqueIDValue(), "¼¼");
        } else {
            tsaleevent = tsaleeventSet.getPao(0);
        }
        tsaleevent.setValue("fsaleevent", fsaleevent, 11L);
        tsaleevent.setValue("fbegdate", fbegdate, 11L);
        tsaleevent.setValue("fenddate", fenddate, 11L);

        tsaleevent.setValue("changeby", username);//޸
        tsaleevent.setValue("changedate", sysdate);//޸ʱ

        saveDataLog(tsaleevent);
        content.put("tsaleeventid", tsaleevent.getString("tsaleeventid"));
        tsaleeventSet.save();

        return query_saleEventMain();
    }


    /**
     * ̽Ӵ¼ɾ
     *
     * @return
     */
    public String saleEventDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tsaleeventid", content.getString("tsaleeventid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

}
