package com.cnd3b.restcontroller.enterprise.agentwebclient.mainpage.archives;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.Random;

public class archives_ad extends Controller {
    public archives_ad(JSONObject content) {
        super(content);
    }

    /**
     * ƹزбѯ
     *
     * @return
     */
    public String query_archivesList() {
        /**
         *
         */
        String[] sortfield = {"t1.checkdate", "t1.fvisitors", "t1.fshares"};
        String sort = getSort(sortfield, "t1.checkdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass1 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass2 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fclass1") && !"".equals(whereObject.getString("fclass1"))) {
                where.append(" and fclass1=").append("'").append(whereObject.getString("fclass1")).append("'");
            }
            if (whereObject.containsKey("fclass2") && !"".equals(whereObject.getString("fclass2"))) {
                where.append(" and fclass2=").append("'").append(whereObject.getString("fclass2")).append("'");
            }
            if (whereObject.containsKey("fmycollection") && whereObject.getBooleanValue("fmycollection")) {
                where.append(" and t2.tarchives_ad_colid is not null");
            }
            if (whereObject.containsKey("fmyarchives") && whereObject.getBooleanValue("fmyarchives")) {
                where.append(" and t1.tagentsid='").append(tagentsid).append("' ");
            } else {
                where.append(" and t1.fstatus='' and t1.tagentsid is null");
                if (fisadministrator) {
                    where.append(" and t1.fagentcanread=1");
                } else {
                    where.append(" and t1.fagentsalercanread=1");
                }
            }
        }
        SQLFactory factory = new SQLFactory(this, "ƹزбѯ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        ArrayList<String> tarchives_adidlist = rows.toArrayList("tarchives_adid");

        SQLFactory coverfactory = new SQLFactory(this, "ѯ");
        coverfactory.addParameter("siteid", siteid);
        coverfactory.addParameter("ownertable", "tarchives_ad");
        coverfactory.addParameter_in("ownerid", tarchives_adidlist);
        RowsMap coverrowsmap = dbConnect.runSqlQuery(coverfactory.getSQL()).toRowsMap("ownerid");

        for (Row row : rows) {
            String tarchives_adid = row.getString("tarchives_adid");
            if (coverrowsmap.containsKey(tarchives_adid)) {
                row.put("docinfos", coverrowsmap.get(tarchives_adid));
            } else {
                row.put("docinfos", "[]");
            }
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ƹزѯ
     *
     * @return
     */
    public String query_archivesMain() throws P2Exception {
        long tarchives_adid = content.getLongValue("tarchives_adid");
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tenterprise_userid", userid);
        sqlFactory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            //ǩ
            String[] flable = dbConnect.runSqlQuery("select flable from tarchives_ad_tag where siteid='" + siteid + "' and tarchives_adid='" + tarchives_adid + "'").toArray("flable");
            row.put("tag", flable);
            Rows fcontent = dbConnect.runSqlQuery("select fcontent from tarchives_ad where siteid='" + siteid + "' and tarchives_adid='" + tarchives_adid + "'");
            row.put("fcontent", fcontent.get(0).getString("fcontent"));
        }
        dbConnect.runSqlUpdate("update tarchives_ad set fvisitors=isnull(fvisitors,0)+1 where siteid='" + siteid + "' and tarchives_adid=" + content.getString("tarchives_adid"));

        PaoSetRemote tarchives_ad_userdataSet = getP2ServerSystemPaoSet("tarchives_ad_userdata");
        PaoRemote tarchives_ad_userdata = tarchives_ad_userdataSet.addAtEnd();
        tarchives_ad_userdata.setValue("siteid", siteid, 11L);
        tarchives_ad_userdata.setValue("tarchives_adid", tarchives_adid, 11L);
        tarchives_ad_userdata.setValue("tenterprise_userid", userid, 11L);
        tarchives_ad_userdata.setValue("createby", username, 11L);
        Calendar calendar = Calendar.getInstance();
        tarchives_ad_userdata.setValue("createdate", calendar.getTime(), 11L);
        calendar.add(Calendar.MINUTE, 5);
        tarchives_ad_userdata.setValue("closedate", calendar.getTime(), 11L);
        tarchives_ad_userdataSet.save();

        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ƹزıǩѯ
     *
     * @return
     */
    public String query_tagList() {
        SQLFactory sql = new SQLFactory(this, "ƹزϵͳǩѯ");
        sql.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ƹز޸
     *
     * @return
     */
    public String archivesInsertOrModify() throws D3bException, P2Exception {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزIDʱĬϴ0
        String fclass1 = content.getString("fclass1");//һ
        String fclass2 = content.getString("fclass2");//
        String ftitle = content.getString("ftitle", "tarchives_ad.ftitle", "زı");//ƹزı
        String fnotes = content.getString("fnotes", "tarchives_ad.fnotes", "زıע");//ƹزıע
        String fcontent = content.getString("fcontent", "tarchives_ad.fcontent", "");//ı
        JSONArray tag = content.getJSONArray("tag");//ǩ

        PaoSetRemote tarchives_adSet = getP2ServerSystemPaoSet("tarchives_ad", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tarchives_adid='" + tarchives_adid + "'");
        PaoRemote tarchives_ad = null;
        if (tarchives_adid <= 0 || tarchives_adSet.isEmpty()) {
            tarchives_ad = tarchives_adSet.addAtEnd();
            tarchives_ad.setValue("siteid", siteid, 11L);//ҵID
            tarchives_ad.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_ad.setValue("createby", username, 11L);//¼
            tarchives_ad.setValue("createdate", sysdate, 11L);//¼ʱ
            tarchives_ad.setValue("fstatus", "½", 11L);//ƹز״̬
            tarchives_ad.setValue("tagentsid", tagentsid, 11L);

            tarchives_adid = tarchives_ad.getLong("tarchives_adid");
        } else {
            tarchives_ad = tarchives_adSet.getPao(0);
        }
        tarchives_ad.setValue("fclass1", fclass1, 11L);
        tarchives_ad.setValue("fclass2", fclass2, 11L);
        tarchives_ad.setValue("ftitle", ftitle, 11L);
        tarchives_ad.setValue("fnotes", fnotes, 11L);
        tarchives_ad.setValue("fcontent", fcontent, 11L);
        tarchives_ad.setValue("changeby", username);//޸
        tarchives_ad.setValue("changedate", sysdate);//޸ʱ

        dbConnect.runSqlUpdate("delete from tarchives_ad_tag where siteid='" + siteid + "' and tarchives_adid=" + tarchives_adid);
        PaoSetRemote tarchives_ad_tagSet = tarchives_ad.getPaoSet("$tarchives_ad_tag", "tarchives_ad_tag");
        Iterator it = tag.iterator();
        while (it.hasNext()) {
            String flable = (String) it.next();
            PaoRemote tarchives_ad_tag = tarchives_ad_tagSet.addAtEnd();
            tarchives_ad_tag.setValue("siteid", siteid, 11L);
            tarchives_ad_tag.setValue("flable", flable, 11L);
            tarchives_ad_tag.setValue("tarchives_adid", tarchives_adid, 11L);
        }
        content.put("tarchives_adid", tarchives_adid);
        saveDataLog(tarchives_ad);
        tarchives_adSet.save();

        return query_archivesMain();
    }


    /**
     * ƹزύ
     *
     * @return
     */
    public String archivesSubmit() {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزID
        SQLFactory factory = new SQLFactory(this, "ƹزύ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tagentsid", tagentsid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        factory.addParameter("submitby", username);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ƹزղ
     *
     * @return
     */
    public String archivesCollection() throws P2Exception {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزID
        boolean iscollection = content.getBooleanValue("iscollection");//Ƿղأ1ղأ0ȡղ

        PaoSetRemote tarchives_ad_collectionSet = getP2ServerSystemPaoSet("tarchives_ad_collection", "siteid='" + siteid + "' and tenterprise_userid='" + userid + "' and tarchives_adid='" + tarchives_adid + "'");
        PaoRemote tarchives_ad_collection = null;
        if (tarchives_ad_collectionSet.isEmpty() && iscollection) {
            tarchives_ad_collection = tarchives_ad_collectionSet.addAtEnd();
            tarchives_ad_collection.setValue("siteid", siteid, 11L);//ҵID
            tarchives_ad_collection.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_ad_collection.setValue("fcollectiondate", sysdate, 11L);//¼ʱ
            tarchives_ad_collection.setValue("tarchives_adid", tarchives_adid, 11L);
        } else if (!tarchives_ad_collectionSet.isEmpty() && !iscollection) {
            tarchives_ad_collectionSet.deleteAll();
        }
        tarchives_ad_collectionSet.save();

        return getSucReturnObject().toString();
    }

    /**
     * ƹزͲѯ
     *
     * @return
     */
    public String getArchivesClass() {
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزķѯ");
        sqlFactory.addParameter("siteid", siteid);
        RowsMap rowsmap = dbConnect.runSqlQuery(sqlFactory.getSQL()).toRowsMap("ftypemx");
        JSONArray array = new JSONArray();
        for (String ftypemx : rowsmap.keySet()) {
            JSONObject object = new JSONObject();
            object.put("fclass1", ftypemx);
            object.put("fclass2", rowsmap.get(ftypemx).toArray("fvalue"));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }

    /**
     * ƹزɾ
     *
     * @return
     */
    public String archiveDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchives_adid", content.getLongValue("tarchives_adid"));
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ƹزķ
     *
     * @return
     */
    public String archiveShare() throws P2Exception {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزID
        String fchannel = content.getString("fchannel");//

        dbConnect.runSqlUpdate("update tarchives_ad set fshares=isnull(fshares,0)+1 where siteid='" + siteid + "' and tarchives_adid=" + content.getString("tarchives_adid"));

        PaoSetRemote tarchives_ad_shareSet = getP2ServerSystemPaoSet("tarchives_ad_share");
        PaoRemote tarchives_ad_share = tarchives_ad_shareSet.addAtEnd();
        tarchives_ad_share.setValue("siteid", siteid, 11L);//ҵID
        tarchives_ad_share.setValue("tenterprise_userid", userid, 11L);//ûID
        tarchives_ad_share.setValue("tarchives_adid", tarchives_adid, 11L);//ƹزID
        tarchives_ad_share.setValue("fchannel", fchannel, 11L);//
        tarchives_ad_share.setValue("createby", username, 11L);//
        tarchives_ad_share.setValue("createdate", getDateTime(), 11L);//ʱ
        tarchives_ad_shareSet.save();
        return getSucReturnObject().toString();
    }

    /**
     * ƹزķͻϢ¼
     *
     * @return
     */
    public String updateArchiveShareForm() throws P2Exception {
        String siteid = content.getString("siteid");//ҵID
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزID
        String fchannel = content.getString("fchannel");//
        String fprovince = content.getString("fprovince");//ÿʡ
        String fcity = content.getString("fcity");//ÿ
        String fcounty = content.getString("fcounty");//ÿ
        String fname = content.getString("fname");//ÿ
        String fphonenumber = content.getString("fphonenumber");//ÿֻ
        String wechat_openid = content.getString("wechat_openid");

        PaoSetRemote tarchives_ad_shareformSet = getP2ServerSystemPaoSet("tarchives_ad_shareform");
        if (fchannel.contains("΢")) {
            tarchives_ad_shareformSet.setWhere("siteid='" + siteid + "' and tenterprise_userid='" + userid + "' and fchannel='" + fchannel + "' and tarchives_adid='" + tarchives_adid + "' and wechat_openid='" + wechat_openid + "'");
        }
        tarchives_ad_shareformSet.reset();

        PaoRemote tarchives_ad_shareform = null;
        if (tarchives_ad_shareformSet.isEmpty()) {
            tarchives_ad_shareform = tarchives_ad_shareformSet.addAtEnd();
            tarchives_ad_shareform.setValue("siteid", siteid, 11L);//ҵID
            tarchives_ad_shareform.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_ad_shareform.setValue("tarchives_adid", tarchives_adid, 11L);//ƹزID
            tarchives_ad_shareform.setValue("fchannel", fchannel, 11L);//
            tarchives_ad_shareform.setValue("createdate", getDateTime(), 11L);//ʱ
            tarchives_ad_shareform.setValue("fvisitors", 1, 11L);
            tarchives_ad_shareform.setValue("wechat_openid", wechat_openid, 11L);
        } else {
            tarchives_ad_shareform = tarchives_ad_shareformSet.getPao(0);
        }
        tarchives_ad_shareform.setValue("fprovince", fprovince, 11L);
        tarchives_ad_shareform.setValue("fcity", fcity, 11L);
        tarchives_ad_shareform.setValue("fcounty", fcounty, 11L);
        tarchives_ad_shareform.setValue("fname", fname, 11L);
        tarchives_ad_shareform.setValue("fphonenumber", fphonenumber, 11L);
        tarchives_ad_shareform.setValue("changedate", getDateTime(), 11L);
        tarchives_ad_shareform.setValue("fvisitors", tarchives_ad_shareform.getInt("fvisitors") + 1, 11L);
        int freadtimes = tarchives_ad_shareform.getInt("freadtimes");
        tarchives_ad_shareform.setValue("freadtimes", freadtimes + (new Random().nextInt(5) + 1) * 60);
        tarchives_ad_shareformSet.save();

        return getSucReturnObject().toString();
    }

    /**
     * 
     *
     * @return
     */
    public String shareStatistics_custlist() {
        /**
         *
         */
        String[] sortfield = {"t1.changedate desc"};
        String sort = getSort(sortfield, "t1.changedate desc");

        SQLFactory factory = new SQLFactory(this, "ƹزķͳ_", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
