package com.cnd3b.restcontroller.enterprise.agentwebclient.mainpage.data;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;

import java.text.SimpleDateFormat;
import java.util.Calendar;

public class analysis extends Controller {
    public analysis(JSONObject content) {
        super(content);
    }

    /**
     * ͻԴͼ
     *
     * @return ѯ
     */
    public String channelofcustomers() {
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");

        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ͻԴ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "ͻԴ").getTips()).saveToDataPool().toString();
    }

    /**
     * ͻ˫ֵ״ͼ
     *
     * @return ѯ
     */
    public String newcustomers() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ͻ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "ͻ").getTips()).saveToDataPool().toString();
    }


    /**
     * ۶©ͼ
     *
     * @return ѯ
     */
    public String customeraction() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "۶");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "۶").getTips()).saveToDataPool().toString();
    }


    /**
     * ͼ
     *
     * @return ѯ
     */
    public String channeloforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "").getTips()).saveToDataPool().toString();
    }

    /**
     * ɽƷ״ͼ
     *
     * @return ѯ
     */
    public String productoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ɽƷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "ɽƷ").getTips()).saveToDataPool().toString();
    }

    /**
     * ͵ֵͼ
     *
     * @return ѯ
     */
    public String amountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "͵ֵ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "͵ֵ").getTips()).saveToDataPool().toString();
    }


    /**
     * Сռȷͼ
     *
     * @return ѯ
     */
    public String communityoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Сռȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "Сռȷ").getTips()).saveToDataPool().toString();
    }

    /**
     * Сȷ
     *
     * @return ѯ
     */
    public String communitydepthoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Сȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "Сȷ").getTips()).saveToDataPool().toString();
    }

    /**
     * ˵ʷͼ
     *
     * @return ѯ
     */
    public String returncountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "˵ʷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "˵ʷ").getTips()).saveToDataPool().toString();
    }


    /**
     * 
     *
     * @return ѯ
     */
    public String customeroforders() {
        /**
         *
         */
        String[] sortfield = {"t1.fdate"};
        String sort = getSort(sortfield, "t1.fdate desc");

        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "").getTips()).saveToDataPool().toString();
    }


    /**
     * ¼ռȷͼ
     *
     * @return ѯ
     */
    public String eventoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "¼ռȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "¼ռȷ").getTips()).saveToDataPool().toString();
    }

    /**
     * ¶÷ͼ
     *
     * @return
     */
    public String costnameofmonth() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "¶÷");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "¶÷").getTips()).saveToDataPool().toString();
    }


    /**
     * ¶ӯͼ
     *
     * @return
     */
    public String costandordersofmonth() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "¶ӯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "¶ӯ").getTips()).saveToDataPool().toString();
    }


    /**
     * ϿͻϢ
     *
     * @return
     */
    public String oldcustomer() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ϿͻϢ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter("pageNumber", pageNumber);
        sqlFactory.addParameter("pageSize", pageSize);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("pageNumber", pageNumber);
        returnObject.put("pageSize", pageSize);
        returnObject.put("total", rows.getTotalRows());
        returnObject.put("pageTotal", rows.getTotalPage());
        returnObject.put("tips", new DataTips(rows, "ϿͻϢ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public String oldcustomerbless() {
        //Ϊ0Ĭȡǰǰ12µ
        SQLFactory sqlFactory = new SQLFactory(this, "Ͽͻάϵͳ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("tips", new DataTips(rows, "Ͽͻάϵͳ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public String oldcustomercycle() {
        //Ϊ0Ĭȡǰǰ12µ
        SQLFactory sqlFactory = new SQLFactory(this, "Ͽͻάϵͳ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("tips", new DataTips(rows, "Ͽͻάϵͳ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }


    /**
     * ͻϢ
     *
     * @return
     */
    public String newcustomer() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ͻϢ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter("pageNumber", pageNumber);
        sqlFactory.addParameter("pageSize", pageSize);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("pageNumber", pageNumber);
        returnObject.put("pageSize", pageSize);
        returnObject.put("total", rows.getTotalRows());
        returnObject.put("pageTotal", rows.getTotalPage());
        returnObject.put("tips", new DataTips(rows, "ͻϢ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * ͻϵͳ
     *
     * @return
     */
    public String newcustomertrack() {
        //Ϊ0Ĭȡǰǰ12µ

        SQLFactory sqlFactory7 = new SQLFactory(this, "ͻϵͳ7");
        sqlFactory7.addParameter("siteid", siteid);
        sqlFactory7.addParameter("tagentsid", tagentsid);
        Rows rows7 = dbConnect.runSqlQuery(sqlFactory7.getSQL());

        SQLFactory sqlFactory14 = new SQLFactory(this, "ͻϵͳ14");
        sqlFactory14.addParameter("siteid", siteid);
        sqlFactory14.addParameter("tagentsid", tagentsid);
        Rows rows14 = dbConnect.runSqlQuery(sqlFactory14.getSQL());

        JSONObject object = new JSONObject();
        object.put("sevendays", rows7.toJsonArray());
        object.put("fourteendays", rows14.toJsonArray());

        returnObject = getSucReturnObject().setData(object);
        returnObject.put("tips", new DataTips("ͻϵͳ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * Ӵ׵ɽͼ
     *
     * @return ѯ
     */
    public String receptiontimesoffirstorder() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Ӵɽ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "Ӵɽ").getTips()).saveToDataPool().toString();
    }

}
