package com.cnd3b.restcontroller.enterprise.salerwebclient.mainpage.agentwork.businesstrip;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class businesstrip extends Controller {
    public businesstrip(JSONObject content) {
        super(content);
    }

    /**
     * гбѯ
     *
     * @return
     */
    public String query_businesstripList() {
        /**
         *
         */
        String[] sortfield = {"t1.changedate"};
        String sort = getSort(sortfield, "t1.changedate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t3.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t4.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("createdate") && !"".equals(whereObject.getString("createdate"))) {
                where.append(" and(");
                where.append("convert(varchar(10),t1.createdate,120) ='").append(whereObject.getString("createdate")).append("' ");
                where.append(")");
            }
            if (whereObject.containsKey("fstatus") && !"".equals(whereObject.getString("fstatus"))) {
                where.append(" and(");
                where.append("fstatus ='").append(whereObject.getString("fstatus")).append("' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "гб", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_in("tenterprise_userid", getSubUsers());
        costhead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * гѯ
     *
     * @return
     */
    public String query_businesstripMain() {

        SQLFactory headsql = new SQLFactory(this, "гѯ");
        headsql.addParameter("siteid", siteid);
        headsql.addParameter("tbusinesstripid", content.getString("tbusinesstripid"));
        Rows rows = dbConnect.runSqlQuery(headsql.getSQL());
        for (Row row : rows) {
            SQLFactory bzwork = new SQLFactory(this, "г̱׼ѯ");
            bzwork.addParameter("siteid", siteid);
            bzwork.addParameter("tbusinesstripid", content.getString("tbusinesstripid"));
            Rows bzworkrows = dbConnect.runSqlQuery(bzwork.getSQL());

            SQLFactory zxwork = new SQLFactory(this, "гѡѯ");
            zxwork.addParameter("siteid", siteid);
            zxwork.addParameter("tbusinesstripid", content.getString("tbusinesstripid"));
            Rows zxworkrows = dbConnect.runSqlQuery(zxwork.getSQL());

            row.put("worklist", bzworkrows.toJsonArray());
            row.put("worklist_zx", zxworkrows.toJsonArray());
            row.put("datalog", getDataLog("tbusinesstripid", row.getString("tbusinesstripid")));

        }

        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * г޸
     *
     * @return
     */
    public String businesstripInsertOrModify() throws D3bException, P2Exception {
        long tagentsid = content.getLongValue("tagentsid");//ID
        long tbusinesstripid = content.getLongValue("tbusinesstripid");//гIDʱĬΪ0

        String fbegdate = content.getString("fbegdate");//
        String fenddate = content.getString("fenddate");//
        String fprovince = content.getString("fprovince");//ʡ
        String fcity = content.getString("fcity");//
        String fcounty = content.getString("fcounty");//
        String fdays = content.getString("fdays");//ͣʱ
        String fnotes = content.getString("fnotes", "tbusinesstrip.fnotes", "ע");//ע
        String fothername = content.getString("fothername", "tbusinesstrip.fothername", "Ա");//Ա

        PaoSetRemote tbusinesstripSet = getP2ServerSystemPaoSet("tbusinesstrip", "siteid='" + siteid + "' and tenterprise_userid='" + userid + "' and tbusinesstripid='" + tbusinesstripid + "'");
        PaoRemote tbusinesstrip = null;
        if (tbusinesstripid <= 0 || tbusinesstripSet.isEmpty()) {
            tbusinesstrip = tbusinesstripSet.addAtEnd();
            tbusinesstrip.setValue("siteid", siteid, 11L);//ҵID
            tbusinesstrip.setValue("tenterprise_userid", userid, 11L);
            tbusinesstrip.setValue("fstatus", "ύ", 11L);//¼״̬
            tbusinesstrip.setValue("fname", username, 11L);//
            tbusinesstrip.setValue("createby", username, 11L);//¼
            tbusinesstrip.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tbusinesstrip = tbusinesstripSet.getPao(0);
        }

        tbusinesstrip.setValue("tagentsid", tagentsid, 11L);//ID
        tbusinesstrip.setValue("fbegdate", fbegdate, 11L);//
        tbusinesstrip.setValue("fenddate", fenddate, 11L);//
        tbusinesstrip.setValue("fprovince", fprovince, 11L);//ʡ
        tbusinesstrip.setValue("fcity", fcity, 11L);//
        tbusinesstrip.setValue("fcounty", fcounty, 11L);//
        tbusinesstrip.setValue("fdays", fdays, 11L);//ͣʱ
        tbusinesstrip.setValue("fnotes", fnotes, 11L);//ע
        tbusinesstrip.setValue("fothername", fothername, 11L);//Ա

        content.put("tbusinesstripid", tbusinesstrip.getUniqueIDValue());
        saveDataLog(tbusinesstrip);
        tbusinesstripSet.save();

        return query_businesstripMain();
    }

    /**
     * г̼¼ɾ
     *
     * @return
     */
    public String businesstripDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "г̼¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tbusinesstripid", content.getLongValue("tbusinesstripid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * г̼¼ύ
     *
     * @return
     */
    public String businesstripSubmit() {
        long tbusinesstripid = content.getLongValue("tbusinesstripid");//гID
        Rows checkrows = dbConnect.runSqlQuery("select *from tbusinesstrip where siteid='" + siteid + "' and tbusinesstripid=" + tbusinesstripid);
        if (checkrows.isEmpty()) {
            return getErrReturnObject().setErrMsg("г̲ڣ").toString();
        } else if (!"ύ".equals(checkrows.getRow(0).getString("fstatus"))) {
            return getErrReturnObject().setErrMsg("гύظύ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "г̼¼ύ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tbusinesstripid", tbusinesstripid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ѡбѯ
     *
     * @return
     */
    public String query_agentList() {
        SQLFactory sqlFactory = new SQLFactory(this, "бѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("fsaleruserid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

}
