package com.cnd3b.restcontroller.enterprise.salerwebclient.mainpage.archives;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Calendar;

public class archives extends Controller {
    public archives(JSONObject content) {
        super(content);
    }

    /**
     * Ӫбѯ
     *
     * @return
     */
    public String query_archivesList() {
        /**
         *
         */
        String[] sortfield = {"t1.checkdate", "t1.fvisitors"};
        String sort = getSort(sortfield, "t1.checkdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fclass1") && !"".equals(whereObject.getString("fclass1"))) {
                where.append(" and fclass1=").append("'").append(whereObject.getString("fclass1")).append("'");
            }
            if (whereObject.containsKey("fclass2") && !"".equals(whereObject.getString("fclass2"))) {
                where.append(" and fclass2=").append("'").append(whereObject.getString("fclass2")).append("'");
            }
            if (whereObject.containsKey("fmycollection") && whereObject.getBooleanValue("fmycollection")) {
                where.append(" and t2.tarchives_collecid is not null");
            }
            if (whereObject.containsKey("fmyarchives") && whereObject.getBooleanValue("fmyarchives")) {
                where.append(" and t1.tenterprise_userid='").append(userid).append("' ");
            } else {
                where.append(" and t1.fstatus=''");
            }
        }
        SQLFactory factory = new SQLFactory(this, "Ӫбѯ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * Ӫѯ
     *
     * @return
     */
    public String query_archivesMain() throws P2Exception {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tenterprise_userid", userid);
        sqlFactory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        dbConnect.runSqlUpdate("update tarchives set fvisitors=isnull(fvisitors,0)+1 where siteid='" + siteid + "' and tarchivesid=" + content.getString("tarchivesid"));

        PaoSetRemote tarchives_userdataSet = getP2ServerSystemPaoSet("tarchives_userdata");
        PaoRemote tarchives_userdata = tarchives_userdataSet.addAtEnd();
        tarchives_userdata.setValue("siteid", siteid, 11L);
        tarchives_userdata.setValue("tarchivesid", tarchivesid, 11L);
        tarchives_userdata.setValue("tenterprise_userid", userid, 11L);
        tarchives_userdata.setValue("createby", username, 11L);
        Calendar calendar = Calendar.getInstance();
        tarchives_userdata.setValue("createdate", calendar.getTime(), 11L);
        calendar.add(Calendar.MINUTE, 5);
        tarchives_userdata.setValue("closedate", calendar.getTime(), 11L);
        tarchives_userdataSet.save();

        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ӫղ
     *
     * @return
     */
    public String archivesCollection() throws P2Exception {
        long tarchivesid = content.getLongValue("tarchivesid");//ӪID
        boolean iscollection = content.getBooleanValue("iscollection");//Ƿղأ1ղأ0ȡղ

        PaoSetRemote tarchives_collectionSet = getP2ServerSystemPaoSet("tarchives_collection", "siteid='" + siteid + "' and tenterprise_userid='" + userid + "' and tarchivesid='" + tarchivesid + "'");
        PaoRemote tarchives_collection = null;
        if (tarchives_collectionSet.isEmpty() && iscollection) {
            tarchives_collection = tarchives_collectionSet.addAtEnd();
            tarchives_collection.setValue("siteid", siteid, 11L);//ҵID
            tarchives_collection.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_collection.setValue("fcollectiondate", sysdate, 11L);//¼ʱ
            tarchives_collection.setValue("tarchivesid", tarchivesid, 11L);
        } else if (!tarchives_collectionSet.isEmpty() && !iscollection) {
            tarchives_collectionSet.deleteAll();
        }
        tarchives_collectionSet.save();

        return getSucReturnObject().toString();
    }

    /**
     * ӪͲѯ
     *
     * @return
     */
    public String getArchivesClass() {
        SQLFactory sqlFactory = new SQLFactory(this, "ӪϷѯ");
        sqlFactory.addParameter("siteid", siteid);
        RowsMap rowsmap = dbConnect.runSqlQuery(sqlFactory.getSQL()).toRowsMap("ftypemx");
        JSONArray array = new JSONArray();
        for (String ftypemx : rowsmap.keySet()) {
            JSONObject object = new JSONObject();
            object.put("fclass1", ftypemx);
            object.put("fclass2", rowsmap.get(ftypemx).toArray("fvalue"));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }

    /**
     * ӪĶ
     *
     * @return
     */
    public String read_analysis() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪĶռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ӪĶ
     *
     * @return
     */
    public String read_analysis_saler() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪĶռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ӫط
     *
     * @return
     */
    public String download_analysis() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ӫط
     *
     * @return
     */
    public String download_analysis_saler() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫδ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");

        SQLFactory factory = new SQLFactory(this, "_Ӫ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives' and t1.ownerid='" + tarchivesid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");

        SQLFactory factory = new SQLFactory(this, "_ӪҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives' and t1.ownerid='" + tarchivesid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫδؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");

        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");

        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
