package com.cnd3b.restcontroller.enterprise.salerwebclient.usercenter.actionscore;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;

public class ActionScore extends Controller {
    public ActionScore(JSONObject content) {
        super(content);
    }

    /**
     * жֵѯ
     *
     * @return
     */
    public String query_total() {
        SQLFactory sqlFactory = new SQLFactory(this, "жֵѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("userid", userid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        if(!rows.isEmpty()){
            return getSucReturnObject().setData(rows.get(0)).saveToDataPool().toString();
        }else{
            return getSucReturnObject().setData(new Row()).saveToDataPool().toString();
        }
    }

    /**
     * ж־
     *
     * @return
     */
    public String query_scorelog() {
        /**
         *
         */
        String[] sortfield = {"t1.submitdate"};
        String sort = getSort(sortfield, "t1.createdate desc");

        SQLFactory sqlFactory = new SQLFactory(this, "жֵ֧ϸѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactionscoreid", content.getString("tactionscoreid"));
        sqlFactory.addParameter("ftypemx", content.getString("ftypemx"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        return getSucReturnObject().setDataByPaging(rows,sortfield).setFinalDo(DataPool.defaultdatalife,1);
    }

    /**
     * 
     *
     * @return
     */
    public String query_taskstatus() {
        SQLFactory sqlFactory = new SQLFactory(this, "ɵѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tenterprise_userid", userid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * жа
     *
     * @return
     */
    public String query_rankinglist() {
        /**
         *
         */
        String[] sortfield = {"t1.fscore desc"};
        String sort = getSort(sortfield, "t1.fscore desc");

        SQLFactory sqlFactory = new SQLFactory(this, "жа", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows,sortfield).setFinalDo(DataPool.defaultdatalife,1);
    }
}
