package com.cnd3b.restcontroller.enterprise.webclient.saleinput;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class saleinput extends Controller {
    public saleinput(JSONObject content) {
        super(content);
    }

    /**
     * ۼ¼б
     *
     * @return
     */
    public String query_saleList() {
        String sort = "t1.fyear desc,t1.fmonth desc,t1.tagentsid ";
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "ۼ¼бѯ", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ۼ¼ѯ
     *
     * @return
     */
    public String query_saleMain() {
        SQLFactory costhead = new SQLFactory(this, "ۼ¼ѯ");
        costhead.addParameter("siteid", siteid);
        costhead.addParameter("tagents_purchaseid", content.getString("tagents_purchaseid"));

        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        for (Row row : rows) {
            row.put("datalog", getDataLog("tagents_purchase", row.getString("tagents_purchaseid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ۼ¼޸
     *
     * @return
     */
    public String saleInsertOrModify() throws P2Exception {
        long tagentsid = content.getLongValue("tagentsid");//ID
        long tagents_purchaseid = content.getLongValue("tagents_purchaseid");//ۼ¼IDʱĬΪ0

        int fyear = content.getIntValue("fyear");//
        int fmonth = content.getIntValue("fmonth");//
        double famount = content.getDoubleValue("famount");//

        PaoSetRemote tagents_purchaseSet = getP2ServerSystemPaoSet("tagents_purchase", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tagents_purchaseid='" + tagents_purchaseid + "'");
        PaoRemote tagents_purchase = null;
        if (tagents_purchaseid <= 0 || tagents_purchaseSet.isEmpty()) {
            tagents_purchase = tagents_purchaseSet.addAtEnd();
            tagents_purchase.setValue("siteid", siteid, 11L);//ҵID
            tagents_purchase.setValue("tagentsid", tagentsid, 11L);//ID
            tagents_purchase.setValue("createby", username, 11L);//¼
            tagents_purchase.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tagents_purchase = tagents_purchaseSet.getPao(0);
        }
        tagents_purchase.setValue("fyear", fyear, 11L);
        tagents_purchase.setValue("fmonth", fmonth, 11L);
        tagents_purchase.setValue("famount", famount, 11L);

        content.put("tagents_purchaseid", tagents_purchase.getUniqueIDValue());
        saveDataLog(tagents_purchase);
        tagents_purchaseSet.save();

        return query_saleMain();
    }

    /**
     * ۼ¼ɾ
     *
     * @return
     */
    public String saleDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ۼ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagents_purchaseid", content.getLongValue("tagents_purchaseid"));
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ѡбѯ
     *
     * @return
     */
    public String query_agentList() {
        SQLFactory sqlFactory = new SQLFactory(this, "бѯ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }
}
