select t1.tagentsid,
       t1.siteid,
       t1.createby,
       t1.createdate,
       t1.changeby,
       t1.changedate,
       t1.fagentnum,
       t1.fagentname,
       t1.fagentshortname,
       t1.fprovince,
       t1.fcity,
       t1.fcounty,
       t1.faddress,
       t1.fcontact,
       t1.fphonenumber,
       t1.fwechatno,
       t1.femail,
       t1.fdutyparagraph,
       t1.fbirthdate,
       t1.fpayment,
       t1.fjoindate,
       t1.fteamsize,
       t1.fbegdate,
       t1.fenddate,
       t1.fcooperationstatus,
       t1.fsaleruserid,
       t2.fname                                                                                         as fsaler,
       t1.fappmodel,
       t1.ftype,
       t4.createdate                                                                                    as factivationtime,
       case when t4.fenddate >= GETDATE() then 'Ч' when t4.createdate IS null then '' else '' end as faccountstatus,
       convert(varchar(10), t6.fdate, 120)                     as ffirstlogintime
from tagents t1
         left join tenterprise_users t2 on t1.siteid = t2.siteid and t1.fsaleruserid = t2.tenterprise_userid
         left join (select max(tpayinfoid) tpayinfoid, siteid, tagentsid from tpayinfo group by siteid, tagentsid) t3
                   on t1.siteid = t3.siteid and t1.tagentsid = t3.tagentsid
         left join tpayinfo t4
                   on t3.siteid = t4.siteid and t3.tagentsid = t4.tagentsid and t3.tpayinfoid = t4.tpayinfoid

         left join (select min(tuserrequestlogid) tuserrequestlogid, siteid, tenterprise_userid
                    from tuserrequestlog
                    group by siteid, tenterprise_userid) t5
                   on t2.siteid = t5.siteid and t2.tenterprise_userid = t5.tenterprise_userid
         left join tuserrequestlog t6 on t5.siteid = t6.siteid and t5.tenterprise_userid = t6.tenterprise_userid and
                                         t5.tuserrequestlogid = t6.tuserrequestlogid
where t1.siteid =$siteid$ and $where$