package com.cnd3b.restcontroller.enterprise.webclient.tagents;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class tagents extends Controller {
    public tagents(JSONObject content) {
        super(content);
    }

    /**
     * ͳ
     *
     * @return
     */
    public String query_analysis() {
        SQLFactory sqlFactory = new SQLFactory(this, "˺żͳ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ҵбѯ
     *
     * @return
     */
    public String query_enterpriseAgentsList() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fagentshortname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fcontact like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("faccountstatus")) {
                if ("Ѹ".equals(whereObject.getString("faccountstatus"))) {
                    where.append("and(t4.fenddate >= GETDATE())");
                } else if ("δ".equals(whereObject.getString("faccountstatus"))) {
                    where.append("and(t4.createdate IS null or t4.fenddate < GETDATE())");
                }
            }
            if (whereObject.containsKey("fsaler") && !"".equals(whereObject.getString("fsaler"))) {
                where.append("and(t2.fname='").append(whereObject.getString("fsaler")).append("')");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and(");
                where.append("t1.ftype like'%").append(whereObject.getString("ftype")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory sql = new SQLFactory(this, "бѯ", pageSize, pageNumber, "t1.tagentsid");
        sql.addParameter("siteid", siteid);
        sql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ҵѡбѯ
     *
     * @return
     */
    public String query_AgentsListselect() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fagentshortname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fsaler") && !"".equals(whereObject.getString("fsaler"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("fsaler")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and(");
                where.append("t1.ftype like'%").append(whereObject.getString("ftype")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory sql = new SQLFactory(this, "ѡбѯ", pageSize, pageNumber, "t1.tagentsid");
        sql.addParameter("siteid", siteid);
        sql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(0, 1);
    }


    /**
     * ҵѯ
     *
     * @return
     */
    public String query_enterpriseAgentsMain() {
        SQLFactory sql = new SQLFactory(this, "ѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ҵ̵޸
     *
     * @return
     */
    public String insert_modify_enterpriseAgent() throws D3bException, P2Exception {
        long tagentsid = content.getLongValue("tagentsid");//IDʱĬϴ0
        String fagentnum = content.getString("fagentnum", "tagents.fagentnum", "̱");//̱
        String fagentname = content.getString("fagentname", "tagents.fagentname", "");//
        String fagentshortname = content.getString("fagentshortname", "tagents.fagentshortname", "̼");//̼
        String faddress = content.getString("faddress", "tagents.faddress", "ϸַ");//ַ
        String fcontact = content.getString("fcontact", "tagents.fcontact", "ϵ");//ϵ
        String fbirthdate = nullToStr(content.getString("fbirthdate"));//
        String fphonenumber = content.getString("fphonenumber", "tagents.fphonenumber", "ϵʽ");//ֻ
        String fwechatno = content.getString("fwechatno", "tagents.fwechatno", "΢ź");//΢ź
        String femail = content.getString("femail", "tagents.femail", "");//
        //String fbegdate = nullToStr(content.getString("fbegdate"));//ʱ
        String fprovince = content.getString("fprovince");//ʡ
        String fcity = content.getString("fcity");//
        String fcounty = content.getString("fcounty");//
        String fdutyparagraph = content.getString("fdutyparagraph", "tagents.fdutyparagraph", "ͳһ");//ͳһô
        //String fenddate = nullToStr(content.getString("fenddate"));//ʱ
        String fjoindate = nullToStr(content.getString("fjoindate"));//
        //String fpayment = content.getString("fpayment");//ѷʽ
        long fsaleruserid = content.getLong("fsaleruserid");//רҵԱID
        int fteamsize = content.getIntValue("fteamsize");//Ŷ
        String fcooperationstatus = content.getString("fcooperationstatus");//״̬
        String ftype = content.getString("ftype");//

        PaoSetRemote tagentsSet = getP2ServerSystemPaoSet("tagents", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
        PaoRemote tagents = null;
        if (tagentsid <= 0 || tagentsSet.isEmpty()) {
            tagents = tagentsSet.addAtEnd();
            tagents.setValue("siteid", siteid, 11L);//ҵID
            tagents.setValue("createby", username, 11L);//¼
            tagents.setValue("createdate", sysdate, 11L);//¼ʱ

        } else {
            tagents = tagentsSet.getPao(0);
        }
        tagents.setValue("fagentnum", fagentnum, 11L);
        tagents.setValue("fagentname", fagentname, 11L);
        tagents.setValue("fagentshortname", fagentshortname, 11L);
        tagents.setValue("faddress", faddress, 11L);
        tagents.setValue("fcontact", fcontact, 11L);
        tagents.setValue("fbirthdate", fbirthdate, 11L);
        tagents.setValue("fphonenumber", fphonenumber, 11L);
        tagents.setValue("fwechatno", fwechatno, 11L);
        tagents.setValue("femail", femail, 11L);
        //tagents.setValue("fbegdate", fbegdate, 11L);
        tagents.setValue("fprovince", fprovince, 11L);
        tagents.setValue("fcity", fcity, 11L);
        tagents.setValue("fcounty", fcounty, 11L);
        tagents.setValue("fdutyparagraph", fdutyparagraph, 11L);
        //tagents.setValue("fenddate", fenddate, 11L);
        tagents.setValue("fjoindate", fjoindate, 11L);
        //tagents.setValue("fpayment", fpayment, 11L);
        tagents.setValue("fsaleruserid", fsaleruserid, 11L);
        tagents.setValue("fteamsize", fteamsize, 11L);
        tagents.setValue("fcooperationstatus", fcooperationstatus, 11L);
        tagents.setValue("ftype", ftype, 11L);

        tagents.setValue("changeby", username, 11L);//޸
        tagents.setValue("changedate", sysdate, 11L);//޸ʱ

        /**
         * ֻԶ󶨵˺
         */
        PaoSetRemote tenterprise_users = tagents.getPaoSet("$tenterprise_users", "tenterprise_users", "siteid='" + siteid + "' and tagentsid=" + tagents.getUniqueIDValue() + " and fisadministrator=1");
        if (!tenterprise_users.isEmpty()) {
            PaoRemote tenterprise_user = tenterprise_users.getPao(0);
            tenterprise_user.setValue("fname", fcontact, 11L);
            tenterprise_user.setValue("fphonenumber", fphonenumber, 11L);
            tenterprise_user.setValue("fbirthdate", fbirthdate, 11L);
            tenterprise_user.setValue("femail", femail, 11L);
            tenterprise_user.setValue("fwechatno", fwechatno, 11L);
        }
        /**
         * ޸־
         */
        saveDataLog(tagents);
        tagentsSet.save();

        return getSucReturnObject().toString();
    }


    /**
     * ҵ̵ɾ
     *
     * @return
     */
    public String delete_enterpriseAgent() {
        SQLFactory sqlFactory = new SQLFactory(this, "̵ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", content.getString("tagentsid"));
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ҵԱ˺Ϣѯ
     *
     * @return
     */
    public String query_enterpriseAgentUsers() {
        SQLFactory sql = new SQLFactory(this, "˺бѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ҵרҵԱѡѯ
     *
     * @return
     */
    public String query_saleruserid() {
        SQLFactory sql = new SQLFactory(this, "רҵԱѡѯ");
        sql.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ̿ͻбѯ
     *
     * @return
     */
    public String query_customer() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fagentshortname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t3.fstorename like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }

        SQLFactory sql = new SQLFactory(this, "̿ͻбѯ", pageSize, pageNumber, "t1.tcustomerid desc");
        sql.addParameter("siteid", siteid);
        sql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * Ӵۼ¼ѯ
     *
     * @return
     */
    public String query_customer_reception() {
        SQLFactory recepitionSQl = new SQLFactory(this, "̿ͻӴ¼бѯ");
        recepitionSQl.addParameter("siteid", siteid);
        recepitionSQl.addParameter("tagentsid", content.getString("tagentsid"));
        recepitionSQl.addParameter("tcustomerid", content.getString("tcustomerid"));
        Rows recepitionrows = dbConnect.runSqlQuery(recepitionSQl.getSQL());

        SQLFactory orderSQl = new SQLFactory(this, "̿ͻۼ¼бѯ");
        orderSQl.addParameter("siteid", siteid);
        orderSQl.addParameter("tagentsid", content.getString("tagentsid"));
        orderSQl.addParameter("tcustomerid", content.getString("tcustomerid"));
        Rows orderrows = dbConnect.runSqlQuery(orderSQl.getSQL());
        for (Row orderrow : orderrows) {
            String tcustomer_receptid = orderrow.getString("tcustomer_receptid");
            SQLFactory ordermxSQl = new SQLFactory(this, "̿ͻۼ¼Ʒбѯ");
            ordermxSQl.addParameter("siteid", siteid);
            ordermxSQl.addParameter("tagentsid", content.getString("tagentsid"));
            ordermxSQl.addParameter("tcustomerid", content.getString("tcustomerid"));
            ordermxSQl.addParameter("tcustomer_receptid", tcustomer_receptid);
            Rows ordermxrows = dbConnect.runSqlQuery(ordermxSQl.getSQL());
            orderrow.put("orders", ordermxrows);
        }
        JSONObject object = new JSONObject();
        object.put("recepitions", recepitionrows.toJsonArray());
        object.put("orders", orderrows.toJsonArray());
        return getSucReturnObject().setData(object).saveToDataPool().toString();
    }


    /**
     * ѡ
     *
     * @return
     */
    public String selectAgenttype() {
        SQLFactory sqlFactory = new SQLFactory(this, "ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        String result = rows.toJsonArray("ftype").toString();
        DataPool.put(content.toString(), result);
        return result;
    }
}
