select t1.tenterprise_userid,
       t1.createby,
       t1.createdate,
       t1.changeby,
       t1.changedate,
       t1.siteid,
       t1.fusertype,
       t1.fname,
       t1.fphonenumber,
       t1.fisadministrator,
       t1.frole,
       t1.fsex,
       t1.fbirthdate,
       t1.femail,
       t1.fwechatno,
       t1.fdatamodify,
       t1.tauthgroupid,
       t1.fissysadministrator,
       t1.faccountno,
       t1.fcanreadagentanalysis,
       t1.faccountbalance,
       convert(varchar(10), t3.fdate, 120)                     as factivationtime,
       case when t3.fdate IS not null then 'Ч' else '' end as faccountstatus
from tenterprise_users t1
         left join (select min(tuserrequestlogid) tuserrequestlogid, siteid, tenterprise_userid
                    from tuserrequestlog
                    group by siteid, tenterprise_userid) t2
                   on t1.siteid = t2.siteid and t1.tenterprise_userid = t2.tenterprise_userid
         left join tuserrequestlog t3 on t2.siteid = t3.siteid and t2.tenterprise_userid = t3.tenterprise_userid and
                                         t2.tuserrequestlogid = t3.tuserrequestlogid
where t1.fusertype = 'ҵ'
  and t1.siteid =$siteid$
  and $where$
  and t1.fissysadministrator=0