select t.siteid,t.tagentsid,t.fmonth, sum(t.ftotalcount)ftotalcount, sum(t.freturncount)freturncount,
       case when convert(float,sum(t.ftotalcount))!=0 then convert(float,sum(t.freturncount)) / convert(float,sum(t.ftotalcount)) else 0 end as freturnrate
from (
         select t1.siteid,t1.tagentsid, CONVERT(varchar(7), fdate, 120) fmonth, count(0) as ftotalcount, 0 as freturncount from tcustomer_reception t1
         where ftype = '' and siteid = $siteid$ and tagentsid=$tagentsid$
           and convert (varchar (7), fdate, 120)>=$fbegmonth$
           and convert (varchar (7), fdate, 120)<=$fendmonth$
         and $where$
         group by CONVERT (varchar (7), fdate, 120),t1.siteid,t1.tagentsid

         union all

         select t1.siteid,t1.tagentsid,CONVERT(varchar(7), fdate, 120) fmonth, 0 as ftotalcount, count(0) as freturncount from tcustomer_reception t1
         where ftype = '' and fstatus = '˵' and siteid = $siteid$ and tagentsid=$tagentsid$
           and convert (varchar (7), fdate, 120)>=$fbegmonth$
           and convert (varchar (7), fdate, 120)<=$fendmonth$
           and $where$
         group by CONVERT (varchar (7), fdate, 120),t1.siteid,t1.tagentsid
         union all
         select  $siteid$,$tagentsid$,fmonth,0,0 from tmonthlist
         where fmonth>=$fbegmonth$ and fmonth<=$fendmonth$ and fmonth<=convert(varchar(7),GETDATE(),120)
     )t group by t.fmonth,t.siteid,t.tagentsid order by t.fmonth