package com.cnd3b.restcontroller.singleagent.appclient.usercenter.teammsg;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

public class teammsg extends Controller {
    public teammsg(JSONObject content) {
        super(content);
    }

    /**
     * ˺бѯ
     *
     * @return
     */
    public String query_userList() {
        SQLFactory sqlFactory = new SQLFactory(this, "˺бѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        SQLFactory subusersql = new SQLFactory(this, "¼˺Ųѯ");
        subusersql.addParameter("siteid", siteid);
        subusersql.addParameter_in("fparentid", rows.toArrayList("tenterprise_userid"));

        RowsMap map = dbConnect.runSqlQuery(subusersql.getSQL()).toRowsMap("fparentid");
        for (Row row : rows) {
            row.put("subusers", map.get(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ˺Ϣ޸
     *
     * @return
     */
    public String update_userMsg() throws D3bException, P2Exception {
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//˺ID
        String fname = content.getString("fname", "tenterprise_users.fname", "");//
        String frole = content.getString("frole", "tenterprise_users.frole", "ְλ");//ְλ
        String fphonenumber = content.getString("fphonenumber", "tenterprise_users.fphonenumber", "ֻ");//ֻ
        JSONArray subusersArray = content.getJSONArray("subusers");
        
        PaoSetRemote tenterprise_usersSet = getP2ServerSystemPaoSet("tenterprise_users", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tenterprise_userid='" + tenterprise_userid + "'");
        PaoRemote pao = null;
        if (tenterprise_userid <= 0 || tenterprise_usersSet.isEmpty()) {
            pao = tenterprise_usersSet.addAtEnd();
            pao.setValue("tagentsid", tagentsid, 11L);
            pao.setValue("fusertype", "", 11L);
            pao.setValue("siteid", siteid, 11L);
            tenterprise_userid = pao.getUniqueIDValue();
        } else {
            pao = tenterprise_usersSet.getPao(0);
        }
        pao.setValue("fname", fname, 11L);
        pao.setValue("frole", frole, 11L);
        pao.setValue("fphonenumber", fphonenumber, 11L);
        pao.setValue("changeby", username, 11L);
        pao.setValue("changedate", getDateTime(), 11L);

        /**
         * ѯ¼˺ţ粻ڣ¼˺
         */
        PaoSetRemote tenterprise_userdetailSet = pao.getPaoSet("$tenterprise_userdetail", "tenterprise_userdetail", "siteid=:siteid and fparentid=:tenterprise_userid");
        HashMap<String, PaoRemote> paoMap = getPaoMap(tenterprise_userdetailSet, "fsubid");

        /**
         * жǷҪɾ
         */
        ArrayList<String> donotdeleteid = new ArrayList<>();

        Iterator subuserlistit = subusersArray.iterator();
        ArrayList<String> distinctid = new ArrayList<>();
        while (subuserlistit.hasNext()) {
            JSONObject subuser = (JSONObject) subuserlistit.next();
            String fsubid = subuser.getString("fsubid");
            if (distinctid.contains(fsubid)) {
                continue;
            } else {
                distinctid.add(fsubid);
            }
            PaoRemote subuserpao = null;
            if (!paoMap.containsKey(fsubid)) {
                subuserpao = tenterprise_userdetailSet.addAtEnd();
                subuserpao.setValue("siteid", siteid, 11L);//ҵID
                subuserpao.setValue("fparentid", tenterprise_userid, 11L);//˺ID
                subuserpao.setValue("fsubid", fsubid, 11L);//¼˺ID
                subuserpao.setValue("createby", username, 11L);//¼
                subuserpao.setValue("createdate", getDateTime(), 11L);//¼ʱ
            } else {
                donotdeleteid.add(fsubid);
                subuserpao = paoMap.get(fsubid);
            }
            subuserpao.setValue("changeby", username, 11L);//޸
            subuserpao.setValue("changedate", getDateTime(), 11L);//޸ʱ
        }
        /**
         * ɾ
         */
        for (String fsubid : paoMap.keySet()) {
            if (!donotdeleteid.contains(fsubid)) {
                if (!paoMap.get(fsubid).isModified()) {
                    paoMap.get(fsubid).delete();
                }
            }
        }
        tenterprise_usersSet.save();
        return getSucReturnObject().toString();
    }

    /**
     * ˺Űŵѡ
     *
     * @return
     */
    public String selectStore() {
        SQLFactory sqlFactory = new SQLFactory(this, "˺Űŵѡ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }
}
