package com.cnd3b.restcontroller.singleagent.webclient.orderinput;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;
import p2.application.tcustomer_reception.tcustomer_reception;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

public class orderinput extends Controller {
    public orderinput(JSONObject content) {
        super(content);
    }


    /**
     * бѯ
     *
     * @return
     */
    public String query_orderList() {

        /**
         *
         */
        String[] sortfield = {"t1.fdate desc"};
        String sort = getSort(sortfield, "t1.fdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");

            //ģ
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fcommunity like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            //ʼʱ
            if (whereObject.containsKey("begdate") && !"".equals(whereObject.getString("begdate"))) {
                where.append(" and convert(varchar(10),t1.fdate,120)>=").append("'").append(whereObject.getString("begdate")).append("'");
            }
            if (whereObject.containsKey("enddate") && !"".equals(whereObject.getString("enddate"))) {
                where.append(" and convert(varchar(10),t1.fdate,120)<=").append("'").append(whereObject.getString("enddate")).append("'");
            }
            /**
             * 
             */
            if (whereObject.containsKey("begbirthdate") && !"".equals(whereObject.getString("begbirthdate")) && whereObject.containsKey("endbirthdate") && !"".equals(whereObject.getString("endbirthdate"))) {
                String begbirthdate = whereObject.getString("begbirthdate");
                String endbirthdate = whereObject.getString("endbirthdate");
                where.append(" and (dateadd(year,datediff(year,t1.fbirthdate,'").append(begbirthdate).append("'),t1.fbirthdate) between '").append(begbirthdate).append("' and '").append(endbirthdate).append("'or dateadd(year,datediff(year,t1.fbirthdate,'").append(endbirthdate).append("'),fbirthdate) between '").append(begbirthdate).append("' and '").append(endbirthdate).append("') ");
            }
            //״̬
            if (whereObject.containsKey("forderstatus") && !"".equals(whereObject.getString("forderstatus"))) {
                if ("ѽ".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fispayout =1 and t1.fstatus =''");
                } else if ("δ".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fispayout =0 and t1.fstatus =''");
                } else if ("ѳ".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fisstockout =1 ");
                } else if ("δ".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fisstockout =0 ");
                } else if ("˵".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fstatus ='˵' ");
                } else if ("".equals(whereObject.getString("forderstatus"))) {
                    where.append(" and t1.fstatus ='' ");
                }
            }
            //Ȩ޽й
            if (!fisadministrator) {
                where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ۼ¼бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).addAppHelpNotes(getAppHelpNotes("ϵͳ")).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ۼ¼ѯ
     *
     * @return
     */
    public String query_orderMain() {
        SQLFactory sqlFactory = new SQLFactory(this, "ۼ¼ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcustomer_receptid", content.getString("tcustomer_receptid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            SQLFactory orderFactory = new SQLFactory(this, "ϸѯ");
            orderFactory.addParameter("siteid", siteid);
            orderFactory.addParameter("tagentsid", tagentsid);
            orderFactory.addParameter("tcustomerid", row.getString("tcustomerid"));
            orderFactory.addParameter("tcustomer_receptid", row.getString("tcustomer_receptid"));
            Rows orderRows = dbConnect.runSqlQuery(orderFactory.getSQL());
            row.put("orderlist", orderRows.toJsonArray());
            row.put("previewurl", "https://www.baidu.com");//Ԥurl
            row.put("datalog", getDataLog("tcustomer_reception", row.getString("tcustomer_receptid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ۼ¼޸
     *
     * @return
     */
    public String orderInsertOrModify() throws D3bException, P2Exception {
        long tcustomer_receptid = content.getLongValue("tcustomer_receptid");//Ӵ¼IDʱĬϴ0
        String fname = content.getString("fname", "tcustomer.fname", "ͻ");//˿
        String fphonenumber = content.getString("fphonenumber", "tcustomer.fphonenumber", "ֻ");//ֻ
        String fcommunity = content.getString("fcommunity", "tcustomer.fcommunity", "С");//С
        String fnumber = content.getString("fnumber", "tcustomer.fnumber", "/Ԫ/");///Ԫ/
        String frenovationplandate = content.getString("frenovationplandate");//ƻװʱ
        Date fbirthdate = content.getDate("fbirthdate");//
        String fwechatno = content.getString("fwechatno", "tcustomer.fwechatno", "΢ź");//΢ź
        String fnotes = content.getString("fnotes", "tcustomer_reception.fnotes", "ע");//ע
        Date fdate = content.getDate("fdate");//µ
        Date finstalldate = content.getDate("finstalldate");//װʱ
        double forderamount = content.getDoubleValue("forderamount");//ɽ
        double freceiveamount = content.getDoubleValue("freceiveamount");//տ

        JSONArray orderlist = content.getJSONArray("orderlist");
        for (Object orderobject : orderlist) {
            JSONObject order = (JSONObject) orderobject;
            order.checkStringLength("fprodname", "tcustomer_order.fprodname", "Ʒ");
        }

        PaoSetRemote tcustomerSet = getP2ServerSystemPaoSet("tcustomer", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and fphonenumber='" + fphonenumber + "'", "tcustomerid desc");
        PaoRemote tcustomer = null;
        if (tcustomerSet.isEmpty()) {
            tcustomer = tcustomerSet.addAtEnd();
            tcustomer.setValue("siteid", siteid, 11L);//ҵID
            tcustomer.setValue("tagentsid", tagentsid, 11L);//ID
            tcustomer.setValue("createby", username, 11L);//¼
            tcustomer.setValue("createdate", sysdate, 11L);//¼ʱ
            tcustomer.setValue("fwaiter", username, 11L);//״νӴ
        } else {
            tcustomer = tcustomerSet.getPao(0);
        }
        tcustomer.setValue("fname", fname, 11L);
        tcustomer.setValue("fphonenumber", fphonenumber, 11L);//ͻֻ
        tcustomer.setValue("fchannel", "", 11L);//Դ
        tcustomer.setValue("fcommunity", fcommunity, 11L);//С
        tcustomer.setValue("fnumber", fnumber, 11L);///Ԫ/
        tcustomer.setValue("frenovationplandate", frenovationplandate, 11L);//ƻװʱ
        tcustomer.setValue("fbirthdate", fbirthdate, 11L);//
        tcustomer.setValue("fwechatno", fwechatno, 11L);//΢ź

        tcustomer.setValue("changeby", username, 11L);//޸
        tcustomer.setValue("changedate", sysdate, 11L);//޸ʱ

        long tcustomerid = tcustomer.getUniqueIDValue();
        /**
         * ѯۼ¼粻ڣۼ¼
         */
        PaoSetRemote tcustomer_receptionSet = tcustomer.getPaoSet("$tcustomer_reception", "tcustomer_reception", "siteid=:siteid and tagentsid=:tagentsid and tcustomer_receptid='" + tcustomer_receptid + "'");
        tcustomer_reception tcustomer_reception = null;
        if (tcustomer_receptid <= 0 || tcustomer_receptionSet.isEmpty()) {
            tcustomer_reception = (tcustomer_reception) tcustomer_receptionSet.addAtEnd();
            tcustomer_reception.setValue("fwaiter", username, 11L);//ӴԱ
            tcustomer_reception.setValue("tenterprise_userid", userid, 11L);//˺ID
            tcustomer_reception.setValue("siteid", siteid, 11L);//ҵID
            tcustomer_reception.setValue("tagentsid", tagentsid, 11L);//ID
            tcustomer_reception.setValue("ftype", "", 11L);//¼
            tcustomer_reception.setValue("fcustaction", "ɽ", 11L);//˿Ͷ¡ƣ

            tcustomer_reception.setValue("fbillnum", tcustomer_reception.getAgentOrderBillNum(Long.parseLong(tagentsid)));
            tcustomer_reception.setValue("createby", username, 11L);//¼
            tcustomer_reception.setValue("createdate", sysdate, 11L);//¼ʱ

            tcustomer.setValue("freceptiontimes", tcustomer.getInt("freceptiontimes") + 1, 11L);

            addActionScore(ActionScore.fsourcetype.¼, tcustomer_reception.getUniqueIDValue(), "¼");

        } else {
            tcustomer_reception = (tcustomer_reception) tcustomer_receptionSet.getPao(0);
        }

        tcustomer_reception.setValue("tcustomerid", tcustomerid, 11L);//ͻID
        tcustomer_reception.setValue("fname", fname, 11L);//˿
        tcustomer_reception.setValue("fphonenumber", fphonenumber, 11L);//ͻֻ
        tcustomer_reception.setValue("fchannel", "", 11L);//Դ
        tcustomer_reception.setValue("fcommunity", fcommunity, 11L);//С
        tcustomer_reception.setValue("fnumber", fnumber, 11L);///Ԫ/
        tcustomer_reception.setValue("frenovationplandate", frenovationplandate, 11L);//ƻװʱ
        tcustomer_reception.setValue("fbirthdate", fbirthdate, 11L);//
        tcustomer_reception.setValue("fwechatno", fwechatno, 11L);//΢ź
        tcustomer_reception.setValue("fdate", fdate, 11L);//µ
        tcustomer_reception.setValue("finstalldate", finstalldate, 11L);//װ
        tcustomer_reception.setValue("fnotes", fnotes, 11L);//ע

        tcustomer_reception.setValue("forderamount", forderamount, 11L);//ɽ
        tcustomer_reception.setValue("fstatus", "", 11L);//״̬

        tcustomer_reception.setValue("changeby", username, 11L);//޸
        tcustomer_reception.setValue("changedate", sysdate, 11L);//޸ʱ

        if (tcustomer.getPaoSet("tcustomer_reception_firstorder").isEmpty()) {
            tcustomer.setValue("freceptiontimes_first", tcustomer.getInt("freceptiontimes"), 11L);
            tcustomer.setValue("ffirstorderid", tcustomer_reception.getUniqueIDValue(), 11L);
        }

        /**
         * ѯϸ粻ڣϸ
         */
        PaoSetRemote tcustomer_orderSet = tcustomer_reception.getPaoSet("$tcustomer_order", "tcustomer_order", "siteid=:siteid and tagentsid=:tagentsid and tcustomer_receptid=:tcustomer_receptid");
        HashMap<String, PaoRemote> paoMap = getPaoMap(tcustomer_orderSet, "tcustomer_orderid");

        /**
         * жǷҪɾ
         */
        ArrayList<String> donotdeleteid = new ArrayList<>();

        for (Object o : orderlist) {
            JSONObject order = (JSONObject) o;
            String tcustomer_orderid = order.getString("tcustomer_orderid");
            String fprodname = order.getString("fprodname");
            String tagents_productid = order.getString("tagents_productid");
            double fqty = order.getDoubleValue("fqty");
            double fprice = order.getDoubleValue("fprice");
            double famount = order.getDoubleValue("famount");

            PaoRemote orderpao = null;
            if ("0".equals(tcustomer_orderid) || !paoMap.containsKey(tcustomer_orderid)) {
                orderpao = tcustomer_orderSet.addAtEnd();
                orderpao.setValue("siteid", siteid, 11L);//ҵID
                orderpao.setValue("tagentsid", tagentsid, 11L);//ID
                orderpao.setValue("tcustomer_receptid", tcustomer_reception.getUniqueIDValue(), 11L);//Ӵ¼id
                orderpao.setValue("createby", username, 11L);//¼
                orderpao.setValue("createdate", sysdate, 11L);//¼ʱ
            } else {
                donotdeleteid.add(tcustomer_orderid);
                orderpao = paoMap.get(tcustomer_orderid);
            }
            orderpao.setValue("tcustomerid", tcustomerid, 11L);//ͻid
            orderpao.setValue("fprodname", fprodname, 11L);
            orderpao.setValue("tagents_productid", tagents_productid, 11L);
            orderpao.setValue("fqty", fqty, 11L);
            orderpao.setValue("fprice", fprice, 11L);
            orderpao.setValue("famount", famount, 11L);

            orderpao.setValue("changeby", username, 11L);//޸
            orderpao.setValue("changedate", sysdate, 11L);//޸ʱ
        }
        /**
         * ɾ
         */
        for (String id : paoMap.keySet()) {
            if (!donotdeleteid.contains(id)) {
                if (!paoMap.get(id).isModified()) {
                    paoMap.get(id).delete();
                }
            }
        }
        String id = tcustomer_reception.getString("tcustomer_receptid");
        content.put("tcustomer_receptid", id);

        saveDataLog(tcustomer_reception);
        tcustomerSet.save();
        //տ¼
        if (freceiveamount > 0) {
            content.put("tcustomerid", tcustomerid);
            content.put("tcustomer_receptid", id);
            content.put("famount", freceiveamount);
            content.put("ftype", "");
            content.put("fnotes", "ױʻ");
            createOrderBill();
        }

        return query_orderMain();
    }

    /**
     * տ¼
     *
     * @return
     */
    public String createOrderBill() throws P2Exception {
        long tcustomerid = content.getLongValue("tcustomerid");//ͻID
        long tcustomer_receptid = content.getLongValue("tcustomer_receptid");//Ӵ¼ID
        double famount = content.getDoubleValue("famount");//տ
        String ftype = content.getString("ftype");//տ
        String fnotes = content.getString("fnotes");//ע
        boolean fispayout = content.getBooleanValue("fispayout");//Ƿѽ
        double freceamount = ftype.equals("˿") ? -famount : famount;

        PaoSetRemote tcustomer_receptionSet = getP2ServerSystemPaoSet("tcustomer_reception", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tcustomerid='" + tcustomerid + "' and tcustomer_receptid='" + tcustomer_receptid + "'");
        if (tcustomer_receptionSet.isEmpty()) {
            return getErrReturnObject().setErrMsg("ҲӦĿͻ").toString();
        }
        PaoRemote tcustomer_reception = tcustomer_receptionSet.getPao(0);

        double forderamount = tcustomer_reception.getDouble("forderamount");//ɽ
        double freceivedamount = tcustomer_reception.getDouble("freceivedamount");//β
        freceivedamount = freceivedamount + freceamount;

        tcustomer_reception.setValue("fispayout", fispayout, 11L);//Ƿѽ
        tcustomer_reception.setValue("freceivedamount", freceivedamount, 11L);//β
        if (fispayout) {
            tcustomer_reception.setValue("freceivablesamount", 0, 11L);//Ӧտ
        } else {
            tcustomer_reception.setValue("freceivablesamount", forderamount - freceivedamount, 11L);//Ӧտ
        }
        if ("".equals(ftype)) {
            tcustomer_reception.setValue("fdepositamount", freceamount, 11L);//
        }
        tcustomer_reception.setValue("changeby", username, 11L);//޸
        tcustomer_reception.setValue("changedate", sysdate, 11L);//޸ʱ

        PaoSetRemote tcustomer_orderbillSet = tcustomer_reception.getPaoSet("$tcustomer_orderbill", "tcustomer_orderbill");
        PaoRemote tcustomer_orderbill = tcustomer_orderbillSet.addAtEnd();
        tcustomer_orderbill.setValue("ftype", ftype, 11L);
        tcustomer_orderbill.setValue("fnotes", fnotes, 11L);
        tcustomer_orderbill.setValue("famount", freceamount, 11L);
        tcustomer_orderbill.setValue("tcustomer_receptid", tcustomer_receptid, 11L);
        tcustomer_orderbill.setValue("tcustomerid", tcustomerid, 11L);
        tcustomer_orderbill.setValue("fispayout", fispayout, 11L);//־

        tcustomer_orderbill.setValue("siteid", siteid, 11L);
        tcustomer_orderbill.setValue("tagentsid", tagentsid, 11L);
        tcustomer_orderbill.setValue("createby", username, 11L);//տ
        tcustomer_orderbill.setValue("createdate", sysdate, 11L);//տʱ
        tcustomer_orderbill.setValue("changeby", username, 11L);//޸
        tcustomer_orderbill.setValue("changedate", sysdate, 11L);//޸ʱ
        tcustomer_receptionSet.save();

        return query_orderMain();
    }

    /**
     * ѯտ¼
     *
     * @return
     */
    public String queryOrderBill() {
        String tcustomerid = content.getString("tcustomerid");//ͻID
        String tcustomer_receptid = content.getString("tcustomer_receptid");//Ӵ¼ID

        SQLFactory sqlFactory = new SQLFactory(this, "տ¼ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcustomerid", tcustomerid);
        sqlFactory.addParameter("tcustomer_receptid", tcustomer_receptid);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ˵
     *
     * @return
     */
    public String orderClose() throws P2Exception {
        long tcustomer_receptid = content.getLongValue("tcustomer_receptid");//Ӵ¼IDʱĬϴ0
        /**
         * ѯۼ¼粻ڣۼ¼
         */
        PaoSetRemote tcustomer_receptionSet = getP2ServerSystemPaoSet("tcustomer_reception", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tcustomer_receptid='" + tcustomer_receptid + "'");
        if (!tcustomer_receptionSet.isEmpty()) {
            PaoRemote tcustomer_reception = tcustomer_receptionSet.getPao(0);
            tcustomer_reception.setValue("fstatus", "˵", 11L);
            tcustomer_reception.setValue("closeby", username, 11L);
            tcustomer_reception.setValue("closedate", getDateTime(), 11L);
            tcustomer_reception.setValue("changeby", username, 11L);//޸
            tcustomer_reception.setValue("changedate", getDateTime(), 11L);//޸ʱ
            saveDataLog(tcustomer_reception);
            tcustomer_receptionSet.save();
        }
        return query_orderMain();
    }


    /**
     * ۼ¼ɾ
     *
     * @return
     */
    public String orderDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ۼ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcustomer_receptid", content.getString("tcustomer_receptid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * СƲѯ
     *
     * @return
     */
    public String queryCommunity() {
        if (content.getString("fcommunity").length() >= 2) {
            SQLFactory sqlFactory = new SQLFactory(this, "Сģѯ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tagentsid", tagentsid);
            sqlFactory.addParameter("fcommunity", "%" + content.getString("fcommunity") + "%");
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            return getSucReturnObject().setData(rows).saveToDataPool().toString();
        } else {
            return getSucReturnObject().setData(new Row()).toString();
        }
    }

    public String queryCustomerByPhoneNumber() {
        if (content.getString("fphonenumber").length() >= 7) {
            SQLFactory sqlFactory = new SQLFactory(this, "ֻŲѯͻ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tagentsid", tagentsid);
            sqlFactory.addParameter("fphonenumber", content.getString("fphonenumber") + "%");
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            return getSucReturnObject().setData(rows).saveToDataPool().toString();
        } else {
            return getSucReturnObject().setData(new Rows()).toString();
        }
    }
}
