package com.cnd3b.common.parameter;

import com.alibaba.fastjson.JSONObject;
public class ErrModel {
	/**
	 * ĲJSONObjectʽҪ
	 * 
	 * @return
	 */
	public static JSONObject request_BasicJsonFormat() {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.jsonFormatErr[0]);
		object.put("msg", ErrCode.jsonFormatErr[1]);
		return object;
	}

	/**
	 * ĵcontentJSONObjectʽҪ
	 * 
	 * @return
	 */
	public static JSONObject request_ContentJsonFormat() {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.jsonContentFormatErr[0]);
		object.put("msg", ErrCode.jsonContentFormatErr[1]);
		return object;
	}

	/**
	 * ûбļֵ
	 * 
	 * @param keyname
	 * @return
	 */
	public static JSONObject request_ContainsMustKey(String keyname) {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.doNotContainsKey[0]);
		object.put("msg", ErrCode.doNotContainsKey[1] + "'" + keyname + "'");
		return object;
	}

	/**
	 * Ҳִʱķ
	 * 
	 * @param msg
	 * @return
	 */
	public static JSONObject request_GetClass(String msg) {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.getClassErr[0]);
		object.put("msg", ErrCode.getClassErr[1] + "'" + msg + "'");
		return object;
	}

	/**
	 * ûµĻȡtokenʧ
	 * 
	 * @return
	 */
	public static JSONObject getToken() {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.gettokenfail[0]);
		object.put("msg", ErrCode.gettokenfail[1]);

		return object;
	}

	/**
	 * ûµĻȡtokenʧ
	 * 
	 * @return
	 */
	public static JSONObject token_Validate() {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("errcode", ErrCode.tokenErr[0]);
		object.put("msg", ErrCode.tokenErr[1]);

		return object;
	}

	public static JSONObject defaultErr(String msg) {
		JSONObject object = new JSONObject();
		object.put("status", "error");
		object.put("msg", msg);
		return object;
	}
}
