select convert(int,SUBSTRING(t.fmonth,6,2))fmonth, sum(t.fcount) fcount, t.freception_address
from (
         select convert(varchar(7),fdate,120)              fmonth,
                freception_address,
                count(freception_address) fcount
         from tcustomer_reception
         where ftype = 'Ӵ'
           and siteid =$siteid$
           and tagentsid=$tagentsid$
           and
                 convert (varchar (7)
                     , fdate
                     , 120)>=$fbegmonth$
           and convert (varchar (7)
                   , fdate
                   , 120)<=$fendmonth$
         group by freception_address, convert(varchar(7),fdate,120)
         union all
         select t1.fmonth, t2.freception_address, 0 as fcount
         from tmonthlist t1
                  inner join (
             select '' freception_address
             union all
             select '' freception_address
         ) t2 on t1.fmonth>=$fbegmonth$ and t1.fmonth<=$fendmonth$ and t1.fmonth<=convert(varchar(7),GETDATE(),120)
     )t
group by convert(int,SUBSTRING(t.fmonth,6,2)), t.freception_address
order by convert(int,SUBSTRING(t.fmonth,6,2))