select distinct fsourcetype as ftaskname
from tactionscore t1
       inner join tactionscoremx t2 on t1.siteid = t2.siteid and t1.tactionscoreid = t2.tactionscoreid
where t1.fusertype = ''
  and t2.ftype = ''
  and t2.ftypemx = ''
  and t1.siteid=$siteid$ and t1.tagentsid = $tagentsid$
  and convert(varchar(10), t2.createdate, 120) = convert(varchar(10), GETDATE(), 120)