package com.cnd3b.restcontroller.enterprise.salerclient.mainpage.agentwork.standardwork;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.HashMap;

public class standardwork extends Controller {
    public standardwork(JSONObject content) {
        super(content);
    }

    /**
     * ׼бѯ
     *
     * @return
     */
    public String query_standardworkList() {
        /**
         *
         */
        String[] sortfield = {"t1.changedate"};
        String sort = getSort(sortfield, "t1.changedate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(" or t3.fstorename like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("createdate") && !"".equals(whereObject.getString("createdate"))) {
                where.append(" and(");
                where.append("convert(varchar(10),t1.createdate,120) ='").append(whereObject.getString("createdate")).append("' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "׼б", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_in("tenterprise_userid", getSubUsers());
        costhead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ׼ѯ
     *
     * @return
     */
    public String query_standardworkMain() {
        SQLFactory headsql = new SQLFactory(this, "׼ѯ");
        headsql.addParameter("siteid", siteid);
        headsql.addParameter("tworkid", content.getString("tworkid"));
        Rows rows = dbConnect.runSqlQuery(headsql.getSQL());
        for (Row row : rows) {
            SQLFactory bzworkmx = new SQLFactory(this, "׼ϸѯ");
            bzworkmx.addParameter("siteid", siteid);
            bzworkmx.addParameter("tworkid", content.getString("tworkid"));
            Rows bzworkrows = dbConnect.runSqlQuery(bzworkmx.getSQL());

            row.put("workmxlist", bzworkrows.toJsonArray());
            row.put("datalog", getDataLog("tbusinesstripid", row.getString("tbusinesstripid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ׼޸
     *
     * @return
     */
    public String standardworkInsertOrModify() throws D3bException, P2Exception {
        long tworkid = content.getLongValue("tworkid");//׼IDʱĬΪ0
        long tbusinesstripid = content.getLongValue("tbusinesstripid");//гID
        int fdays = content.getIntValue("fdays");//ʱ
        long tagentsid = content.getLongValue("tagentsid");//id
        long tstoreid = content.getLongValue("tstoreid");//ŵID
        String fdate = content.getString("fdate");

        JSONArray workmx = content.getJSONArray("workmx");
        for (Object object : workmx) {
            JSONObject workmxobject = (JSONObject) object;
            workmxobject.getString("fnotes", "tworkmx.fnotes", "ע");
        }

        PaoSetRemote tworkSet = getP2ServerSystemPaoSet("twork", "siteid='" + siteid + "' and tworkid='" + tworkid + "'");
        PaoRemote twork = null;
        if (tbusinesstripid <= 0 || tworkSet.isEmpty()) {
            twork = tworkSet.addAtEnd();
            twork.setValue("siteid", siteid, 11L);//ҵID
            twork.setValue("fworktype", "׼", 11L);//
            twork.setValue("tagentsid", tagentsid, 11L);//ID
            twork.setValue("tbusinesstripid", tbusinesstripid, 11L);
            twork.setValue("createby", username, 11L);//¼
            twork.setValue("createdate", sysdate, 11L);//¼ʱ

            addActionScore(ActionScore.fsourcetype.׼¼, twork.getUniqueIDValue(), "׼¼");
        } else {
            twork = tworkSet.getPao(0);
        }
        twork.setValue("tstoreid", tstoreid, 11L);//ŵid
        twork.setValue("fdate", fdate, 11L);
        twork.setValue("fdays", fdays, 11L);//ʱ
        twork.setValue("changeby", username, 11L);//޸
        twork.setValue("changedate", sysdate, 11L);//޸ʱ
        PaoSetRemote tworkmxSet = twork.getPaoSet("$tworkmx", "tworkmx", "siteid='" + siteid + "' and tbusinesstripid=" + tbusinesstripid + " and tworkid=" + tworkid);
        HashMap<String, PaoRemote> paomap = getPaoMap(tworkmxSet, "fworkname");
        for (Object o : workmx) {
            JSONObject workmxobject = (JSONObject) o;
            long tworkmxid = workmxobject.getLongValue("tworkmxid");
            String ftype = workmxobject.getString("ftype");
            String fworkname = workmxobject.getString("fworkname");
            String fnotes = workmxobject.getString("fnotes");
            int fdocqty = workmxobject.getIntValue("fdocqty");
            boolean fisimage = workmxobject.getBooleanValue("fisimage");
            boolean fiseditnote = workmxobject.getBooleanValue("fiseditnote");

            PaoRemote tworkmx = null;
            if (tworkmxid <= 0 || !paomap.containsKey(fworkname)) {
                tworkmx = tworkmxSet.addAtEnd();
                tworkmx.setValue("siteid", siteid, 11L);//ҵID
                tworkmx.setValue("tbusinesstripid", tbusinesstripid, 11L);
                tworkmx.setValue("tworkid", twork.getUniqueIDValue(), 11L);//
                tworkmx.setValue("ftype", ftype, 11L);//ŵꡢ
                tworkmx.setValue("fworkname", fworkname, 11L);//
                tworkmx.setValue("fdocqty", fdocqty, 11L);//
                tworkmx.setValue("fisimage", fisimage, 11L);//ǷͼƬ
                tworkmx.setValue("fiseditnote", fiseditnote, 11L);//ǷҪע
            } else {
                tworkmx = paomap.get(fworkname);
            }
            tworkmx.setValue("fnotes", fnotes, 11L);//ע
        }
        content.put("tworkid", twork.getUniqueIDValue());
        saveDataLog(twork);
        tworkSet.save();

        return query_standardworkMain();
    }

    /**
     * ׼ɾ
     *
     * @return
     */
    public String standardworkDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "׼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tworkid", content.getString("tworkid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }
    /**
     * гֱӴӳгбвѯ
     */
    /**
     * ŵѡбѯ
     *
     * @return
     */
    public String query_agentstoreList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵбѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ׼ģбѯ
     *
     * @return
     */
    public String query_standardworkTemplateList() {
        SQLFactory sql = new SQLFactory(this, "׼ģѯ");
        sql.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

}
