package com.cnd3b.restcontroller.enterprise.salerclient.mainpage.notice;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

public class notice extends Controller {
    public notice(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_noticeList() {
        /**
         *
         */
        String[] sortfield = {"t1.fisontop desc,t1.checkdate desc"};
        String sort = getSort(sortfield, "t1.fisontop desc,t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fsummary like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory noticehead = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tenterprise_userid", userid);
        noticehead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());
        ArrayList<String> tnoticeidlist = rows.toArrayList("tnoticeid");

        SQLFactory noticeisread = new SQLFactory(this, "бǷѶѯ");
        noticeisread.addParameter("siteid", siteid);
        noticeisread.addParameter("tenterprise_userid", userid);
        noticeisread.addParameter_in("tnoticeid", tnoticeidlist);
        List tnoticeids = Arrays.asList(dbConnect.runSqlQuery(noticeisread.getSQL()).toArray("tnoticeid"));


        SQLFactory noticereadcount = new SQLFactory(this, "Ķѯ");
        noticereadcount.addParameter("siteid", siteid);
        noticereadcount.addParameter_in("tnoticeid", tnoticeidlist);
        RowsMap noticereadcountMap = dbConnect.runSqlQuery(noticereadcount.getSQL()).toRowsMap("tnoticeid");

        RowsMap tattachmentcountcountMap = getAttachmentQty("tnotice", tnoticeidlist);

        for (Row row : rows) {
            String tnoticeid = row.getString("tnoticeid");
            /**
             * ǷѶ
             */
            if (tnoticeids.contains(tnoticeid)) {
                row.put("fisread", 1);
            } else {
                row.put("fisread", 0);
            }
            /**
             * Ķѯ
             */
            if (noticereadcountMap.containsKey(tnoticeid)) {
                row.put("freadcount", noticereadcountMap.get(tnoticeid).get(0).getInteger("freadcount"));
            } else {
                row.put("freadcount", 0);
            }

            /**
             * ѯ
             */
            if (tattachmentcountcountMap.containsKey(tnoticeid)) {
                row.put("fattachmentcount", tattachmentcountcountMap.get(tnoticeid).get(0).getInteger("fattachmentcount"));
            } else {
                row.put("fattachmentcount", 0);
            }
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ѯ(Ķ)
     *
     * @return
     */
    public String query_noticeMain() throws P2Exception {
        long tnoticeid = content.getLongValue("tnoticeid");
        SQLFactory noticehead = new SQLFactory(this, "ѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        if (!rows.isEmpty()) {
            Row row = rows.get(0);
            /**
             * Ķ
             */
            SQLFactory noticereadcount = new SQLFactory(this, "Ķѯ");
            noticereadcount.addParameter("siteid", siteid);
            noticereadcount.addParameter_in("tnoticeid", String.valueOf(tnoticeid));
            Rows noticereadcountRows = dbConnect.runSqlQuery(noticereadcount.getSQL());
            if (!noticereadcountRows.isEmpty()) {
                row.put("freadcount", noticereadcountRows.get(0).getInteger("freadcount") + 1);
            } else {
                row.put("freadcount", 1);
            }

            /**
             * ּ
             */
            SQLFactory noticeleavemessage = new SQLFactory(this, "ּԲѯ");
            noticeleavemessage.addParameter("siteid", siteid);
            noticeleavemessage.addParameter("tnoticeid", tnoticeid);
            noticeleavemessage.addParameter("tenterprise_userid", userid);
            Rows noticeleavemessageRows = dbConnect.runSqlQuery(noticeleavemessage.getSQL());
            if (!noticeleavemessageRows.isEmpty()) {
                row.put("fleavemessage", noticeleavemessageRows.get(0).getString("fleavemessage"));
                row.put("fscore", noticeleavemessageRows.get(0).getInteger("fscore"));
            } else {
                row.put("fleavemessage", "");
                row.put("fscore", 0);
            }

            SQLFactory agentsql = new SQLFactory(this, "澭Ϣѯ");
            agentsql.addParameter("siteid", siteid);
            agentsql.addParameter("tnoticeid", tnoticeid);
            agentsql.addParameter_in("fsaleruserid", getSubUsers());
            Rows agentRows = dbConnect.runSqlQuery(agentsql.getSQL());


            RowsMap freadstatusMap = agentRows.toRowsMap("freadstatus");
            RowsMap fdownloadstatusMap = agentRows.toRowsMap("fdownloadstatus");

            //
            row.put("ftotalusercount", agentRows.size());
            //
            if (freadstatusMap.containsKey("")) {
                row.put("freadusercount", freadstatusMap.get("").size());
            } else {
                row.put("freadusercount", 0);
            }
            //
            if (fdownloadstatusMap.containsKey("")) {
                row.put("fdownloadusercount", fdownloadstatusMap.get("").size());
            } else {
                row.put("fdownloadusercount", 0);
            }

            Rows evaluationsRows = dbConnect.runSqlQuery("select count(0)evaluations from tnotice_users where siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "' and fscore>0");
            row.put("evaluations", evaluationsRows.get(0).getInteger("evaluations"));

            RowsMap salerRowsMap = getUser(agentRows.toArray("fsaleruserid"));
            /**
             * δб
             */
            JSONArray unreadArray = new JSONArray();
            Rows unreadrows = freadstatusMap.get("δ");
            Rows readrows = freadstatusMap.get("");
            RowsMap unreadrowsMap = unreadrows.toRowsMap("fsaleruserid");
            RowsMap readrowsMap = readrows.toRowsMap("fsaleruserid");
            for (String fsaleruserid : unreadrowsMap.keySet()) {
                JSONObject object = new JSONObject();
                object.put("fsaler", salerRowsMap.get(fsaleruserid).get(0).getString("fname"));
                object.put("ftotalusercount", unreadrowsMap.get(fsaleruserid).size());
                object.put("fdoneusercount", readrowsMap.get(fsaleruserid).size());
                object.put("userlist", unreadrowsMap.get(fsaleruserid).toJsonArray());
                unreadArray.add(object);
            }
            row.put("unreadmsg", unreadArray);
            /**
             * δб
             */
            JSONArray undownloadArray = new JSONArray();
            Rows undownloadrows = fdownloadstatusMap.get("δ");
            Rows downloadrows = fdownloadstatusMap.get("");
            RowsMap undownloadrowsMap = undownloadrows.toRowsMap("fsaleruserid");
            RowsMap downloadrowsMap = downloadrows.toRowsMap("fsaleruserid");
            for (String fsaleruserid : undownloadrowsMap.keySet()) {
                JSONObject object = new JSONObject();
                object.put("fsaler", salerRowsMap.get(fsaleruserid).get(0).getString("fname"));
                object.put("ftotalusercount", undownloadrowsMap.get(fsaleruserid).size());
                object.put("fdoneusercount", downloadrowsMap.get(fsaleruserid).size());
                object.put("userlist", undownloadrowsMap.get(fsaleruserid).toJsonArray());
                undownloadArray.add(object);
            }
            row.put("undownloadmsg", undownloadArray);
        }

        PaoSetRemote tnotice_userdataSet = getP2ServerSystemPaoSet("tnotice_userdata");
        PaoRemote tnotice_userdata = tnotice_userdataSet.addAtEnd();
        tnotice_userdata.setValue("siteid", siteid, 11L);
        tnotice_userdata.setValue("tnoticeid", tnoticeid, 11L);
        tnotice_userdata.setValue("tenterprise_userid", userid, 11L);
        tnotice_userdata.setValue("createby", username, 11L);
        Calendar calendar = Calendar.getInstance();
        tnotice_userdata.setValue("createdate", calendar.getTime(), 11L);
        calendar.add(Calendar.MINUTE, 5);
        tnotice_userdata.setValue("closedate", calendar.getTime(), 11L);
        tnotice_userdataSet.save();
        dbConnect.runSqlUpdate("update tnotice_users set flastreadtime=getdate() where siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "' and tenterprise_userid='" + userid + "'");
        addActionScore(ActionScore.fsourcetype.Ķͨ, tnoticeid, "Ķͨ");

        return getSucReturnObject().setData(rows).toString();
    }

    public String noticeexit() {
        String tnoticeid = content.getString("tnoticeid");
        dbConnect.runSqlUpdate("update top(1) tnotice_userdata set closedate=getdate() where siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "' and tenterprise_userid='" + userid + "'");
        return getSucReturnObject().toString();
    }

    /**
     * ּ
     *
     * @return
     */
    public String notice_returnMessage() throws P2Exception {
        long tnoticeid = content.getLongValue("tnoticeid");
        String fleavemessage = content.getString("fleavemessage");
        int fscore = content.getIntValue("fscore");
        /**
         * 
         */
        PaoSetRemote tnotice_usersSet = getP2ServerSystemPaoSet("tnotice_users", "siteid='" + siteid + "' and tnoticeid=" + tnoticeid + " and tenterprise_userid='" + userid + "'");
        PaoRemote tnotice_users = null;
        if (!tnotice_usersSet.isEmpty()) {
            tnotice_users = tnotice_usersSet.getPao(0);
            tnotice_users.setValue("fleavemessage", fleavemessage, 11L);
            tnotice_users.setValue("fscore", fscore, 11L);
            tnotice_users.setValue("changeby", username, 11L);
            tnotice_users.setValue("changedate", getDateTime(), 11L);
        } else {
            tnotice_users = tnotice_usersSet.addAtEnd();
            tnotice_users.setValue("siteid", siteid);
            tnotice_users.setValue("tenterprise_userid", userid);
            tnotice_users.setValue("tnoticeid", tnoticeid);
            tnotice_users.setValue("fleavemessage", fleavemessage, 11L);
            tnotice_users.setValue("fscore", fscore, 11L);
            tnotice_users.setValue("changeby", username, 11L);
            tnotice_users.setValue("changedate", getDateTime(), 11L);
        }
        tnotice_usersSet.save();
        addActionScore(ActionScore.fsourcetype.ͨ, tnoticeid, "ͨ");

        return getSucReturnObject().toString();
    }

}
