package com.cnd3b.restcontroller.enterprise.salerwebclient.mainpage.action.storeinput;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.actionscore.ActionScore;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Date;

public class storeinput extends Controller {
    public storeinput(JSONObject content) {
        super(content);
    }

    /**
     * ҵԱ̵бѯ
     *
     * @return
     */
    public String query_storeList() {
        String sort = "t1.tagentsid,t1.fagentname";
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fstorename like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "ŵбѯ", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_in("fsaleruserid", getSubUsers());
        costhead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ŵѯ
     *
     * @return
     */
    public String query_storeMain() {
        SQLFactory costhead = new SQLFactory(this, "ŵѯ");
        costhead.addParameter("siteid", siteid);
        costhead.addParameter("tagentsid", content.getString("tagentsid"));
        costhead.addParameter("tstoreid", content.getString("tstoreid"));

        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        for (Row row : rows) {
            row.put("datalog", getDataLog("tstore", row.getString("tstoreid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ŵ޸
     *
     * @return
     */
    public String storeInsertOrModify() throws D3bException, P2Exception {
        long tagentsid = content.getLongValue("tagentsid");//ID
        long tstoreid = content.getLongValue("tstoreid");//ŵIDʱĬϴ0

        String fstorenum = content.getString("fstorenum", "tstore.fstorenum", "ŵ");//ŵ
        String fstorename = content.getString("fstorename", "tstore.fstorename", "ŵ");//ŵ
        double farea = content.getDoubleValue("farea");//ŵ
        String fstoretype = content.getString("fstoretype");//ŵ
        String fmarket = content.getString("fmarket");//

        String fstartdate = content.getString("fstartdate");//
        String fstatus = content.getString("fstatus");//ŵ״̬
        String fprovince = content.getString("fprovince");//ʡ
        String fcity = content.getString("fcity");//
        String fcounty = content.getString("fcounty");//
        String faddress = content.getString("faddress", "tstore.faddress", "ϸַ");//ŵַ

        String fcontact = content.getString("fcontact", "tstore.fcontact", "ŵ긺");//ϵ
        String fphonenumber = content.getString("fphonenumber", "tstore.fphonenumber", "ֻ");//ϵʽ
        String femail = content.getString("femail", "tstore.femail", "");//
        String fwechatno = content.getString("fwechatno", "tstore.fwechatno", "΢");//΢ź

        PaoSetRemote tstoreSet = getP2ServerSystemPaoSet("tstore", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tstoreid='" + tstoreid + "'");
        PaoRemote tstore = null;
        if (tstoreid <= 0 || tstoreSet.isEmpty()) {
            tstore = tstoreSet.addAtEnd();
            tstore.setValue("siteid", siteid, 11L);//ҵID
            tstore.setValue("tagentsid", tagentsid, 11L);//ID
            tstore.setValue("createby", username, 11L);//¼
            tstore.setValue("createdate", sysdate, 11L);//¼ʱ

            addActionScore(ActionScore.fsourcetype.¼, tstore.getUniqueIDValue(), "¼");
        } else {
            tstore = tstoreSet.getPao(0);
        }
        tstore.setValue("fstorenum", fstorenum, 11L);//ŵ
        tstore.setValue("fstorename", fstorename, 11L);//ŵ
        tstore.setValue("farea", farea, 11L);//ŵ
        tstore.setValue("fstoretype", fstoretype, 11L);//ŵ
        tstore.setValue("fmarket", fmarket, 11L);//
        tstore.setValue("fstartdate", fstartdate, 11L);//
        tstore.setValue("fstatus", fstatus, 11L);//ŵ״̬
        tstore.setValue("fprovince", fprovince, 11L);//ʡ
        tstore.setValue("fcity", fcity, 11L);//
        tstore.setValue("fcounty", fcounty, 11L);//
        tstore.setValue("faddress", faddress, 11L);//ŵַ


        tstore.setValue("fcontact", fcontact, 11L);//ϵ
        tstore.setValue("fphonenumber", fphonenumber, 11L);//ϵʽ
        tstore.setValue("femail", femail, 11L);//
        tstore.setValue("fwechatno", fwechatno, 11L);//΢

        tstore.setValue("changeby", username, 11L);//޸
        tstore.setValue("changedate", sysdate, 11L);//޸ʱ

        content.put("tstoreid", tstore.getUniqueIDValue());
        saveDataLog(tstore);
        tstoreSet.save();

        return query_storeMain();
    }


    /**
     * ŵɾ
     *
     * @return
     */
    public String storeDelete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", content.getLongValue("tagentsid"));
        sqlFactory.addParameter("tstoreid", content.getLongValue("tstoreid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ѡбѯ
     *
     * @return
     */
    public String query_agentList() {
        SQLFactory sqlFactory = new SQLFactory(this, "бѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("fsaleruserid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_marketList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ŵѡ
     *
     * @return
     */
    public String query_storetypeList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ŵ״̬ѡ
     *
     * @return
     */
    public String query_storestatusList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŵ״̬ѡ");
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ŵĽ
     *
     * @return
     */
    public String storeRebuild() throws D3bException, P2Exception {
        long tagentsid = content.getLongValue("tagentsid");//ID
        long tstoreid = content.getLongValue("tstoreid");//ŵID
        String fdate = content.getString("fdate");//Ľ
        String ftype = content.getString("ftype");//Ľ
        double farea = content.getDoubleValue("farea");//ŵ
        String fnotes = content.getString("fnotes", "tstore_rebuildlog.fnotes", "Ľ˵");//Ľ˵

        PaoSetRemote tstore = getP2ServerSystemPaoSet("tstore", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tstoreid='" + tstoreid + "'");
        if (!tstore.isEmpty()) {
            PaoSetRemote tstore_rebuildlogSet = tstore.getPao(0).getPaoSet("tstore_rebuildlog");
            tstore_rebuildlogSet.setOrderBy("fdate desc");
            tstore_rebuildlogSet.reset();
            Date lasttime;//һηʱ
            if (tstore_rebuildlogSet.isEmpty()) {
                //֮ǰûз¹ԽΪһηʱ
                lasttime = tstore.getPao(0).getDate("fstartdate");
            } else {
                lasttime = tstore_rebuildlogSet.getPao(0).getDate("fdate");
            }

            PaoRemote tstore_rebuildlog = tstore_rebuildlogSet.addAtEnd();
            tstore_rebuildlog.setValue("siteid", siteid, 11L);//ҵID
            tstore_rebuildlog.setValue("tagentsid", tagentsid, 11L);//ID
            tstore_rebuildlog.setValue("tstoreid", tstoreid, 11L);//ŵID

            tstore_rebuildlog.setValue("fdate", fdate, 11L);//Ľ
            tstore_rebuildlog.setValue("farea", farea, 11L);//ŵ
            tstore_rebuildlog.setValue("ftype", ftype, 11L);//Ľ
            tstore_rebuildlog.setValue("fnotes", fnotes, 11L);//Ľ˵

            tstore_rebuildlog.setValue("createby", username, 11L);//¼
            tstore_rebuildlog.setValue("createdate", sysdate, 11L);//¼ʱ
            tstore_rebuildlog.setValue("changeby", username, 11L);//޸
            tstore_rebuildlog.setValue("changedate", sysdate, 11L);//޸ʱ

            float times = tstore_rebuildlog.getDate("fdate").getTime() - lasttime.getTime();
            tstore_rebuildlog.setValue("fintervaltime", times / (float) (1000 * 60 * 60 * 24));

            tstore.getPao(0).setValue("farea", farea, 11L);
            tstore.save();
        }
        return getSucReturnObject().toString();
    }

}
