select case when t4.tattachment_downid IS null then 'δ' else '' end as ftype,
       count(distinct t2.tenterprise_userid)                             as fcount
from tarchives_sc t1
         inner join tenterprise_users t2 on t1.siteid = t2.siteid and t2.fphonenumber is not null
    and t1.fagentcanread = 1 and t2.fusertype = '' and t2.fisadministrator = 1
         inner join tattachment t3
                    on t1.siteid = t3.siteid and t3.ownertable = 'tarchives_sc' and t3.ownerid = t1.tarchives_scid
         left join tattachment_downlog t4 on t3.siteid = t4.siteid and t3.tattachmentid = t4.tattachmentid and
                                             t2.tenterprise_userid = t4.tenterprise_userid
where t1.siteid = $siteid$ and t1.tarchives_scid=$tarchives_scid$
group by case when t4.tattachment_downid IS null then 'δ'
else''end
