package com.cnd3b.restcontroller.enterprise.webclient.archives;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;

public class archives extends Controller {
    public archives(JSONObject content) {
        super(content);
    }

    /**
     * Ӫбѯ
     *
     * @return
     */
    public String query_archivesList() {
        /**
         *
         */
        String[] sortfield = {"t1.checkdate", "t1.fvisitors"};
        String sort = getSort(sortfield, "t1.checkdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass1 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass2 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fclass1") && !"".equals(whereObject.getString("fclass1"))) {
                where.append(" and fclass1=").append("'").append(whereObject.getString("fclass1")).append("'");
            }
            if (whereObject.containsKey("fclass2") && !"".equals(whereObject.getString("fclass2"))) {
                where.append(" and fclass2=").append("'").append(whereObject.getString("fclass2")).append("'");
            }
        }
        SQLFactory factory = new SQLFactory(this, "Ӫбѯ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * Ӫѯ
     *
     * @return
     */
    public String query_archivesMain() {
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchivesid", content.getString("tarchivesid"));
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ӫ޸
     *
     * @return
     */
    public String archivesInsertOrModify() throws D3bException, P2Exception {
        long tarchivesid = content.getLongValue("tarchivesid");//ӪIDʱĬϴ0
        if (tarchivesid > 0) {
            if (dbConnect.runSqlQuery("select * from tarchives where siteid='" + siteid + "' and fstatus='½' and tarchivesid=" + tarchivesid).isEmpty()) {
                return getErrReturnObject().setErrMsg("ǰ״̬޸ģ").toString();
            }
        }
        String fclass1 = content.getString("fclass1");//һ
        String fclass2 = content.getString("fclass2");//
        String ftitle = content.getString("ftitle", "tarchives.ftitle", "");//Ӫϱ
        String fnotes = content.getString("fnotes", "tarchives.fnotes", "ע");//Ӫϱע
        boolean fsalercanread = content.getBooleanValue("fsalercanread");//ҵԱǷɼ
        boolean fagentcanread = content.getBooleanValue("fagentcanread");//ס˺Ƿɼ
        boolean fagentsalercanread = content.getBooleanValue("fagentsalercanread");//˺Ƿɼ

        PaoSetRemote tarchivesSet = getP2ServerSystemPaoSet("tarchives", "siteid='" + siteid + "' and tarchivesid='" + tarchivesid + "'");
        PaoRemote tarchives = null;
        if (tarchivesid == 0 || tarchivesSet.isEmpty()) {
            tarchives = tarchivesSet.addAtEnd();
            tarchives.setValue("siteid", siteid, 11L);//ҵID
            tarchives.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives.setValue("createby", username, 11L);//¼
            tarchives.setValue("createdate", sysdate, 11L);//¼ʱ
            tarchives.setValue("fstatus", "½", 11L);//Ӫ״̬
        } else {
            tarchives = tarchivesSet.getPao(0);
        }
        tarchives.setValue("fclass1", fclass1, 11L);
        tarchives.setValue("fclass2", fclass2, 11L);
        tarchives.setValue("ftitle", ftitle, 11L);
        tarchives.setValue("fnotes", fnotes, 11L);
        tarchives.setValue("fsalercanread", fsalercanread, 11L);
        tarchives.setValue("fagentcanread", fagentcanread, 11L);
        tarchives.setValue("fagentsalercanread", fagentsalercanread, 11L);

        tarchives.setValue("changeby", username);//޸
        tarchives.setValue("changedate", sysdate);//޸ʱ

        content.put("tarchivesid", tarchives.getString("tarchivesid"));
        saveDataLog(tarchives);
        tarchivesSet.save();

        return query_archivesMain();
    }

    /**
     * ӪϷ
     *
     * @return
     */
    public String archivesCheck() {
        long tarchivesid = content.getLongValue("tarchivesid");
        if (!dbConnect.runSqlQuery("select * from tarchives where siteid='" + siteid + "' and fstatus='' and tarchivesid=" + tarchivesid).isEmpty()) {
            return getErrReturnObject().setErrMsg("Ӫѷظ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "ӪϷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        factory.addParameter("checkby", username);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            SQLFactory sqlFactory = new SQLFactory(this, "Ӫѯ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tarchivesid", content.getString("tarchivesid"));
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            if (!rows.isEmpty()) {
                String fclass1 = rows.get(0).getString("fclass1");
                String fclass2 = rows.get(0).getString("fclass2");
                String ftitle = rows.get(0).getString("ftitle");
                String tagentsid = rows.get(0).getString("tagentsid");

                SQLFactory msgfac = new SQLFactory(this, "Ϣ");
                msgfac.addParameter("siteid", siteid);
                msgfac.addParameter("objectname", "tarchives");
                msgfac.addParameter("objectid", tarchivesid);
                msgfac.addParameter("fmessage", "·һ" + fclass1 + "-" + fclass2 + "Ӫϣ" + ftitle + "");
                dbConnect.runSqlUpdate(msgfac.getSQL());
            }
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * Ӫȡ
     *
     * @return
     */
    public String archivesUnCheck() {
        long tarchivesid = content.getLongValue("tarchivesid");//ӪIDʱĬϴ0
        if (dbConnect.runSqlQuery("select * from tarchives where siteid='" + siteid + "' and fstatus='' and tarchivesid=" + tarchivesid).isEmpty()) {
            return getErrReturnObject().setErrMsg("Ӫϲڷ״̬ȡ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "Ӫȡ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ӪϷѯ
     *
     * @return
     */
    public String getArchivesClass() {
        SQLFactory sqlFactory = new SQLFactory(this, "ӪϷѯ");
        sqlFactory.addParameter("siteid", siteid);
        RowsMap rowsmap = dbConnect.runSqlQuery(sqlFactory.getSQL()).toRowsMap("ftypemx");
        JSONArray array = new JSONArray();
        for (String ftypemx : rowsmap.keySet()) {
            JSONObject object = new JSONObject();
            object.put("fclass1", ftypemx);
            object.put("fclass2", rowsmap.get(ftypemx).toArray("fvalue"));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }


    /**
     * Ӫɾ
     *
     * @return
     */
    public String archiveDelete() {
        long tarchivesid = content.getLongValue("tarchivesid");
        if (dbConnect.runSqlQuery("select * from tarchives where siteid='" + siteid + "' and fstatus='½' and tarchivesid=" + tarchivesid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "Ӫɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchivesid", tarchivesid);

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * ӪĶ
     *
     * @return
     */
    public String read_analysis() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪĶռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ӪĶ
     *
     * @return
     */
    public String read_analysis_saler() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪĶռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ӫط
     *
     * @return
     */
    public String download_analysis() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ӫط
     *
     * @return
     */
    public String download_analysis_saler() {
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫδ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");

        SQLFactory factory = new SQLFactory(this, "_Ӫ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives' and t1.ownerid='" + tarchivesid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");

        SQLFactory factory = new SQLFactory(this, "_ӪҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives' and t1.ownerid='" + tarchivesid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫδؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");

        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_Ӫؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");

        long tarchivesid = content.getLongValue("tarchivesid");
        SQLFactory factory = new SQLFactory(this, "_ӪҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchivesid", tarchivesid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
