package com.cnd3b.restcontroller.enterprise.webclient.archives;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;

public class archives_ad extends Controller {
    public archives_ad(JSONObject content) {
        super(content);
    }

    /**
     * ƹزбѯ
     *
     * @return
     */
    public String query_archivesList() {
        /**
         *
         */
        String[] sortfield = {"t1.tarchives_adid desc"};
        String sort = getSort(sortfield, "t1.tarchives_adid desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass1 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass2 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fclass1") && !"".equals(whereObject.getString("fclass1"))) {
                where.append(" and fclass1=").append("'").append(whereObject.getString("fclass1")).append("'");
            }
            if (whereObject.containsKey("fclass2") && !"".equals(whereObject.getString("fclass2"))) {
                where.append(" and fclass2=").append("'").append(whereObject.getString("fclass2")).append("'");
            }
        }
        SQLFactory factory = new SQLFactory(this, "ƹزбѯ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ƹزѯ
     *
     * @return
     */
    public String query_archivesMain() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            //ǩ
            String[] flable = dbConnect.runSqlQuery("select flable from tarchives_ad_tag where siteid='" + siteid + "' and tarchives_adid='" + tarchives_adid + "'").toArray("flable");
            row.put("tag", flable);
            Rows fcontent = dbConnect.runSqlQuery("select fcontent from tarchives_ad where siteid='" + siteid + "' and tarchives_adid='" + tarchives_adid + "'");
            row.put("fcontent", fcontent.get(0).getString("fcontent"));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ƹز޸
     *
     * @return
     */
    public String archivesInsertOrModify() throws D3bException, P2Exception {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزIDʱĬϴ0
        if (tarchives_adid > 0) {
            if (dbConnect.runSqlQuery("select fstatus from tarchives_ad where siteid='" + siteid + "' and fstatus='½' and tarchives_adid=" + tarchives_adid).isEmpty()) {
                return getErrReturnObject().setErrMsg("ǰ״̬޸").toString();
            }
        }
        String fclass1 = content.getString("fclass1", "tarchives_ad.ftitle", "");//һ
        String fclass2 = content.getString("fclass2", "tarchives_ad.fnotes", "ע");//
        String ftitle = content.getString("ftitle");//ƹزı
        String fnotes = content.getString("fnotes");//ƹزıע
        String fcontent = content.getString("fcontent", "tarchives_ad.fcontent", "");//ı
        boolean fsalercanread = content.getBooleanValue("fsalercanread");//ҵԱǷɼ
        boolean fagentcanread = content.getBooleanValue("fagentcanread");//ס˺Ƿɼ
        boolean fagentsalercanread = content.getBooleanValue("fagentsalercanread");//˺Ƿɼ
        JSONArray tag = content.getJSONArray("tag");//ǩ

        PaoSetRemote tarchives_adSet = getP2ServerSystemPaoSet("tarchives_ad", "siteid='" + siteid + "' and tarchives_adid='" + tarchives_adid + "'");
        PaoRemote tarchives_ad = null;
        if (tarchives_adid <= 0 || tarchives_adSet.isEmpty()) {
            tarchives_ad = tarchives_adSet.addAtEnd();
            tarchives_ad.setValue("siteid", siteid, 11L);//ҵID
            tarchives_ad.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_ad.setValue("createby", username, 11L);//¼
            tarchives_ad.setValue("createdate", sysdate, 11L);//¼ʱ
            tarchives_ad.setValue("fstatus", "½", 11L);//ƹز״̬
        } else {
            tarchives_ad = tarchives_adSet.getPao(0);
        }
        tarchives_ad.setValue("fclass1", fclass1, 11L);
        tarchives_ad.setValue("fclass2", fclass2, 11L);
        tarchives_ad.setValue("ftitle", ftitle, 11L);
        tarchives_ad.setValue("fnotes", fnotes, 11L);
        tarchives_ad.setValue("fcontent", fcontent, 11L);

        tarchives_ad.setValue("fsalercanread", fsalercanread, 11L);
        tarchives_ad.setValue("fagentcanread", fagentcanread, 11L);
        tarchives_ad.setValue("fagentsalercanread", fagentsalercanread, 11L);

        tarchives_ad.setValue("changeby", username);//޸
        tarchives_ad.setValue("changedate", sysdate);//޸ʱ

        /**
         * ǩ
         */
        dbConnect.runSqlUpdate("delete from tarchives_ad_tag where siteid='" + siteid + "' and tarchives_adid=" + tarchives_adid);
        PaoSetRemote tarchives_ad_tagSet = tarchives_ad.getPaoSet("$tarchives_ad_tag", "tarchives_ad_tag");
        for (Object o : tag) {
            String flable = (String) o;
            PaoRemote tarchives_ad_tag = tarchives_ad_tagSet.addAtEnd();
            tarchives_ad_tag.setValue("siteid", siteid, 11L);
            tarchives_ad_tag.setValue("flable", flable, 11L);
            tarchives_ad_tag.setValue("tarchives_adid", tarchives_adid, 11L);
        }

        content.put("tarchives_adid", tarchives_ad.getString("tarchives_adid"));
        saveDataLog(tarchives_ad);
        tarchives_adSet.save();

        return query_archivesMain();
    }

    /**
     * ƹز
     *
     * @return
     */
    public String archivesCheck() {
        long tarchives_adid = content.getLongValue("tarchives_adid");//ƹزIDʱĬϴ0
        if (!dbConnect.runSqlQuery("select * from tarchives_ad where siteid='" + siteid + "' and fstatus='' and tarchives_adid=" + tarchives_adid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ƹزѷظ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "ƹزķ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        factory.addParameter("checkby", username);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            SQLFactory sqlFactory = new SQLFactory(this, "ƹزѯ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tarchives_adid", content.getString("tarchives_adid"));
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            if (!rows.isEmpty()) {
                String fclass1 = rows.get(0).getString("fclass1");
                String fclass2 = rows.get(0).getString("fclass2");
                String ftitle = rows.get(0).getString("ftitle");
                String tagentsid = rows.get(0).getString("tagentsid");

                SQLFactory msgfac = new SQLFactory(this, "Ϣ");
                msgfac.addParameter("siteid", siteid);
                msgfac.addParameter("objectname", "tarchives_ad");
                msgfac.addParameter("objectid", tarchives_adid);
                msgfac.addParameter("fmessage", "·һ" + fclass1 + "-" + fclass2 + "ƹزģ" + ftitle + "");
                dbConnect.runSqlUpdate(msgfac.getSQL());

//                if (tagentsid != null && !"null".equalsIgnoreCase(tagentsid) && !"".equals(tagentsid)) {
//                    String tenterprise_userid = rows.get(0).getString("tenterprise_userid");
//                    String submitby = rows.get(0).getString("submitby");
//                    new AgentActionScore(siteid, tagentsid, tenterprise_userid, submitby, ActionScore.fsourcetype.ǿ, Long.parseLong(tarchives_adid), "ǿ").add();
//                }
            }
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ƹزIDȡ
     *
     * @return
     */
    public String archivesUnCheck() {
        String tarchives_adid = content.getString("tarchives_adid");//ƹزIDʱĬϴ0
        if (dbConnect.runSqlQuery("select * from tarchives_ad where siteid='" + siteid + "' and fstatus='' and tarchives_adid=" + tarchives_adid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ƹزĲڷ״̬ȡ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "ƹزȡ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ƹزķѯ
     *
     * @return
     */
    public String getArchivesClass() {
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزķѯ");
        sqlFactory.addParameter("siteid", siteid);
        RowsMap rowsmap = dbConnect.runSqlQuery(sqlFactory.getSQL()).toRowsMap("ftypemx");
        JSONArray array = new JSONArray();
        for (String ftypemx : rowsmap.keySet()) {
            JSONObject object = new JSONObject();
            object.put("fclass1", ftypemx);
            object.put("fclass2", rowsmap.get(ftypemx).toArray("fvalue"));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }


    /**
     * ƹزɾ
     *
     * @return
     */
    public String archiveDelete() {
        long tarchives_adid = content.getLongValue("tarchives_adid");
        if (dbConnect.runSqlQuery("select * from tarchives_ad where siteid='" + siteid + "' and fstatus='½' and tarchives_adid=" + tarchives_adid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ƹزɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchives_adid", tarchives_adid);

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * ƹزĶ
     *
     * @return
     */
    public String read_analysis() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزĶռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ƹزĶ
     *
     * @return
     */
    public String read_analysis_saler() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزĶռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ƹزط
     *
     * @return
     */
    public String download_analysis() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ƹزط
     *
     * @return
     */
    public String download_analysis_saler() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزδ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");

        SQLFactory factory = new SQLFactory(this, "_ƹز", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives_ad' and t1.ownerid='" + tarchives_adid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");

        SQLFactory factory = new SQLFactory(this, "_ƹزҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives_ad' and t1.ownerid='" + tarchives_adid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزδؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");

        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");

        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "_ƹزҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ͳ
     * 
     *
     * @return
     */
    public String shareStatistics() {
        String tarchives_adid = content.getString("tarchives_adid");
        /**
         *
         */
        String[] sortfield = {"t1.tarchives_adid"};
        String sort = getSort(sortfield, "t1.tarchives_adid");

        SQLFactory factory = new SQLFactory(this, "ƹزķͳ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ͳ,
     *
     * @return
     */
    public String shareStatistics_custlist() {
        String tarchives_adid = content.getString("tarchives_adid");
        String tenterprise_userid = content.getString("tenterprise_userid");
        /**
         *
         */
        String[] sortfield = {"t1.createdate desc"};
        String sort = getSort(sortfield, "t1.createdate desc");

        SQLFactory factory = new SQLFactory(this, "ƹزķͳ_", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        factory.addParameter("tenterprise_userid", tenterprise_userid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ͳ
     *
     * @return
     */
    public String shareChannelStatistics() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "ƹزķͳ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ͳ
     *
     * @return
     */
    public String shareCustChannelStatistics() {
        String tarchives_adid = content.getString("tarchives_adid");
        SQLFactory factory = new SQLFactory(this, "ƹزͳ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_adid", tarchives_adid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }
}
