package com.cnd3b.restcontroller.enterprise.webclient.archives;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;

public class archives_sc extends Controller {
    public archives_sc(JSONObject content) {
        super(content);
    }

    /**
     * ѧԺμбѯ
     *
     * @return
     */
    public String query_archivesList() {
        /**
         *
         */
        String[] sortfield = {"t1.checkdate", "t1.fvisitors"};
        String sort = getSort(sortfield, "t1.checkdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass1 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fclass2 like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fclass1") && !"".equals(whereObject.getString("fclass1"))) {
                where.append(" and fclass1=").append("'").append(whereObject.getString("fclass1")).append("'");
            }
            if (whereObject.containsKey("fclass2") && !"".equals(whereObject.getString("fclass2"))) {
                where.append(" and fclass2=").append("'").append(whereObject.getString("fclass2")).append("'");
            }
        }
        SQLFactory factory = new SQLFactory(this, "ѧԺμбѯ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ѧԺμѯ
     *
     * @return
     */
    public String query_archivesMain() {
        String tarchives_scid = content.getString("tarchives_scid");
        SQLFactory sqlFactory = new SQLFactory(this, "ѧԺμѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            //ǩ
            String[] flable = dbConnect.runSqlQuery("select flable from tarchives_sc_tag where siteid='" + siteid + "' and tarchives_scid='" + tarchives_scid + "'").toArray("flable");
            row.put("tag", flable);
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ѧԺμ޸
     *
     * @return
     */
    public String archivesInsertOrModify() throws D3bException, P2Exception {
        long tarchives_scid = content.getLongValue("tarchives_scid");//ѧԺμIDʱĬϴ0
        if (tarchives_scid > 0) {
            if (dbConnect.runSqlQuery("select * from tarchives_sc where siteid='" + siteid + "' and fstatus='½' and tarchives_scid=" + tarchives_scid).isEmpty()) {
                return getErrReturnObject().setErrMsg("ǰ״̬޸ģ").toString();
            }
        }
        String fclass1 = content.getString("fclass1");//һ
        String fclass2 = content.getString("fclass2");//
        String ftitle = content.getString("ftitle", "tarchives_sc.ftitle", "");//ѧԺμ
        String fnotes = content.getString("fnotes", "tarchives_sc.fnotes", "ע");//ѧԺμע
        boolean fissecret = content.getBooleanValue("fissecret");//
        String fenddate = nullToStr(content.getString("fenddate"));//μЧ
        boolean fsalercanread = content.getBooleanValue("fsalercanread");//ҵԱǷɼ
        boolean fagentcanread = content.getBooleanValue("fagentcanread");//ס˺Ƿɼ
        boolean fagentsalercanread = content.getBooleanValue("fagentsalercanread");//˺Ƿɼ
        JSONArray tag = content.getJSONArray("tag");//ǩ

        PaoSetRemote tarchives_scSet = getP2ServerSystemPaoSet("tarchives_sc", "siteid='" + siteid + "' and tarchives_scid='" + tarchives_scid + "'");
        PaoRemote tarchives_sc = null;
        if (tarchives_scid <= 0 || tarchives_scSet.isEmpty()) {
            tarchives_sc = tarchives_scSet.addAtEnd();
            tarchives_sc.setValue("siteid", siteid, 11L);//ҵID
            tarchives_sc.setValue("tenterprise_userid", userid, 11L);//ûID
            tarchives_sc.setValue("createby", username, 11L);//¼
            tarchives_sc.setValue("createdate", sysdate, 11L);//¼ʱ
            tarchives_sc.setValue("fstatus", "½", 11L);//ѧԺμ״̬
        } else {
            tarchives_sc = tarchives_scSet.getPao(0);
        }
        tarchives_sc.setValue("fclass1", fclass1, 11L);
        tarchives_sc.setValue("fclass2", fclass2, 11L);
        tarchives_sc.setValue("ftitle", ftitle, 11L);
        tarchives_sc.setValue("fnotes", fnotes, 11L);
        tarchives_sc.setValue("fissecret", fissecret, 11L);
        tarchives_sc.setValue("fenddate", fenddate, 11L);
        tarchives_sc.setValue("fsalercanread", fsalercanread, 11L);
        tarchives_sc.setValue("fagentcanread", fagentcanread, 11L);
        tarchives_sc.setValue("fagentsalercanread", fagentsalercanread, 11L);
        tarchives_sc.setValue("changeby", username);//޸
        tarchives_sc.setValue("changedate", sysdate);//޸ʱ
        /**
         * ǩ
         */
        dbConnect.runSqlUpdate("delete from tarchives_sc_tag where siteid='" + siteid + "' and tarchives_scid=" + tarchives_scid);
        PaoSetRemote tarchives_sc_tagSet = tarchives_sc.getPaoSet("$tarchives_sc_tag", "tarchives_sc_tag");
        for (Object o : tag) {
            String flable = (String) o;
            PaoRemote tarchives_sc_tag = tarchives_sc_tagSet.addAtEnd();
            tarchives_sc_tag.setValue("siteid", siteid, 11L);
            tarchives_sc_tag.setValue("flable", flable, 11L);
            tarchives_sc_tag.setValue("tarchives_scid", tarchives_scid, 11L);
        }
        content.put("tarchives_scid", tarchives_sc.getString("tarchives_scid"));
        saveDataLog(tarchives_sc);
        tarchives_scSet.save();

        return query_archivesMain();
    }

    /**
     * ѧԺμ
     *
     * @return
     */
    public String archivesCheck() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        if (!dbConnect.runSqlQuery("select * from tarchives_sc where siteid='" + siteid + "' and fstatus='' and tarchives_scid=" + tarchives_scid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ѧԺμѷظ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "ѧԺμ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        factory.addParameter("checkby", username);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            SQLFactory sqlFactory = new SQLFactory(this, "ѧԺμѯ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tarchives_scid", content.getString("tarchives_scid"));
            Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
            if (!rows.isEmpty()) {
                String fclass1 = rows.get(0).getString("fclass1");
                String fclass2 = rows.get(0).getString("fclass2");
                String ftitle = rows.get(0).getString("ftitle");
                long tagentsid = rows.get(0).getLong("tagentsid");

                SQLFactory msgfac = new SQLFactory(this, "Ϣ");
                msgfac.addParameter("siteid", siteid);
                msgfac.addParameter("objectname", "tarchives_sc");
                msgfac.addParameter("objectid", tarchives_scid);
                msgfac.addParameter("fmessage", "·һ" + fclass1 + "-" + fclass2 + "ѧԺμ" + ftitle + "");
                dbConnect.runSqlUpdate(msgfac.getSQL());
            }
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }


    /**
     * ѧԺμȡ
     *
     * @return
     */
    public String archivesUnCheck() {
        String tarchives_scid = content.getString("tarchives_scid");//ѧԺμIDʱĬϴ0
        if (dbConnect.runSqlQuery("select * from tarchives_sc where siteid='" + siteid + "' and fstatus='' and tarchives_scid=" + tarchives_scid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ѧԺμڷ״̬ȡ").toString();
        }
        SQLFactory factory = new SQLFactory(this, "ѧԺμȡ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        String status = dbConnect.runSqlUpdate(factory.getSQL());
        if (status.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ѧԺμѯ
     *
     * @return
     */
    public String getArchivesClass() {
        SQLFactory sqlFactory = new SQLFactory(this, "ѧԺμѯ");
        sqlFactory.addParameter("siteid", siteid);
        RowsMap rowsmap = dbConnect.runSqlQuery(sqlFactory.getSQL()).toRowsMap("ftypemx");
        JSONArray array = new JSONArray();
        for (String ftypemx : rowsmap.keySet()) {
            JSONObject object = new JSONObject();
            object.put("fclass1", ftypemx);
            object.put("fclass2", rowsmap.get(ftypemx).toArray("fvalue"));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }


    /**
     * ѧԺμɾ
     *
     * @return
     */
    public String archiveDelete() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        if (tarchives_scid > 0) {
            if (dbConnect.runSqlQuery("select * from tarchives_sc where siteid='" + siteid + "' and fstatus='½' and tarchives_scid=" + tarchives_scid).isEmpty()) {
                return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ѧԺμɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tarchives_scid", tarchives_scid);
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * ѧԺμĶ
     *
     * @return
     */
    public String read_analysis() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμĶռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ѧԺμҵԱĶ
     *
     * @return
     */
    public String read_analysis_saler() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμĶռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ѧԺμط
     *
     * @return
     */
    public String download_analysis() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμռȷ_");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ѧԺμҵԱط
     *
     * @return
     */
    public String download_analysis_saler() {
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμռȷ_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμδ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");

        SQLFactory factory = new SQLFactory(this, "_ѧԺμ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives_sc' and t1.ownerid='" + tarchives_scid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");

        SQLFactory factory = new SQLFactory(this, "_ѧԺμҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tarchives_sc' and t1.ownerid='" + tarchives_scid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμδؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");
        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμδҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");

        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t2.tenterprise_userid"};
        String sort = getSort(sortfield, "t2.tenterprise_userid");

        long tarchives_scid = content.getLongValue("tarchives_scid");
        SQLFactory factory = new SQLFactory(this, "_ѧԺμҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tarchives_scid", tarchives_scid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
