select t.fmonth, sum(t.ftotalcount)ftotalcount, sum(t.freturncount)freturncount,
       case when convert(float,sum(t.ftotalcount))!=0 then convert(float,sum(t.freturncount)) / convert(float,sum(t.ftotalcount)) else 0 end as freturnrate
from (
        select CONVERT(varchar(7), t1.fdate, 120) fmonth, count(0) as ftotalcount, 0 as freturncount from DSBCRM..tcustomer_reception t1
        inner join DSBCRM..tagents t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid
        where t1.ftype = '' and t1.siteid =$siteid$
        and convert (varchar (7), t1.fdate, 120)>=$fbegmonth$
        and convert (varchar (7), t1.fdate, 120)<=$fendmonth$
        group by CONVERT (varchar (7), t1.fdate, 120)

        union all

        select CONVERT(varchar(7), t1.fdate, 120) fmonth, 0 as ftotalcount, count(0) as freturncount from DSBCRM..tcustomer_reception t1
        inner join DSBCRM..tagents t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid
        where t1.ftype = '' and t1.fstatus = '˵' and t1.siteid =$siteid$
        and convert (varchar (7), t1.fdate, 120)>=$fbegmonth$
        and convert (varchar (7), t1.fdate, 120)<=$fendmonth$
        group by CONVERT (varchar (7), t1.fdate, 120)

        union all
        select fmonth,0,0 from tmonthlist
        where fmonth>=$fbegmonth$ and fmonth<=$fendmonth$ and fmonth<=convert(varchar(7),GETDATE(),120)
)as t group by t.fmonth