package com.cnd3b.restcontroller.enterprise.webclient.notice;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;

public class notice extends Controller {
    public notice(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_noticeList() {
        /**
         *
         */
        String[] sortfield = {"t1.fisontop desc,t1.checkdate desc"};
        String sort = getSort(sortfield, "t1.fisontop desc,t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fsummary like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory noticehead = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());
        String[] tnoticeids = rows.toArray("tnoticeid");

        SQLFactory noticereadcount = new SQLFactory(this, "Ķѯ");
        noticereadcount.addParameter("siteid", siteid);
        noticereadcount.addParameter_in("tnoticeid", tnoticeids);
        RowsMap noticereadcountMap = dbConnect.runSqlQuery(noticereadcount.getSQL()).toRowsMap("tnoticeid");

        SQLFactory tattachmentcount = new SQLFactory(this, "ѯ");
        tattachmentcount.addParameter("siteid", siteid);
        tattachmentcount.addParameter_in("tnoticeid", tnoticeids);
        RowsMap tattachmentcountcountMap = dbConnect.runSqlQuery(tattachmentcount.getSQL()).toRowsMap("tnoticeid");


        for (Row row : rows) {
            String tnoticeid = row.getString("tnoticeid");
            /**
             * Ķѯ
             */
            if (noticereadcountMap.containsKey(tnoticeid)) {
                row.put("freadcount", noticereadcountMap.get(tnoticeid).get(0).getInteger("freadcount"));
            } else {
                row.put("freadcount", 0);
            }

            /**
             * ѯ
             */
            if (tattachmentcountcountMap.containsKey(tnoticeid)) {
                row.put("fattachmentcount", tattachmentcountcountMap.get(tnoticeid).get(0).getInteger("fattachmentcount"));
            } else {
                row.put("fattachmentcount", 0);
            }

        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ѯ(Ķ)
     *
     * @return
     */
    public String query_noticeMain() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory noticehead = new SQLFactory(this, "ѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        SQLFactory noticereadcount = new SQLFactory(this, "Ķѯ");
        noticereadcount.addParameter("siteid", siteid);
        noticereadcount.addParameter_in("tnoticeid", tnoticeid);
        Rows noticereadcountRows = dbConnect.runSqlQuery(noticereadcount.getSQL());

        if (!rows.isEmpty()) {
            /**
             * Ķ
             */
            if (!noticereadcountRows.isEmpty()) {
                rows.get(0).put("freadcount", noticereadcountRows.get(0).getInteger("freadcount") + 1);
            } else {
                rows.get(0).put("freadcount", 1);
            }
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ּԲѯ
     *
     * @return
     */
    public String query_noticeLeavemessageList() {
        /**
         *
         */
        String[] sortfield = {"t1.createdate"};
        String sort = getSort(sortfield, "t1.createdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("fscore")) {
                where.append(" and(");
                where.append("t1.fscore ='").append(whereObject.getString("fscore")).append("' ");
                where.append(")");
            }
        }

        SQLFactory noticeleavemessage = new SQLFactory(this, "ּбѯ", pageSize, pageNumber, sort);
        noticeleavemessage.addParameter("siteid", siteid);
        noticeleavemessage.addParameter("tnoticeid", content.getString("tnoticeid"));
        noticeleavemessage.addParameter_SQL("where", where);
        Rows noticeleavemessageRows = dbConnect.runSqlQuery(noticeleavemessage.getSQL());
        return getSucReturnObject().setDataByPaging(noticeleavemessageRows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    public String noticeontop() {
        String tnoticeid = content.getString("tnoticeid");
        String fisontop = content.getString("fisontop");//Ƿö
        String status = dbConnect.runSqlUpdate("update tnotice set fisontop=" + fisontop + ", changeby='" + username + "',changedate=getdate() where siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "'");
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ޸
     *
     * @return
     */
    public String insertOrModify() throws D3bException, P2Exception {
        long tnoticeid = content.getLongValue("tnoticeid"); //ʱĬϴ0
        String ftype = content.getString("ftype");//
        String ftitle = content.getString("ftitle", "tnotice.ftitle", "");//
        String fsummary = content.getString("fsummary", "tnotice.fsummary", "ͨ浼");//
        String fcontent = content.getString("fcontent", "tnotice.fcontent", "");//
        boolean fissecret = content.getBooleanValue("fissecret");//Ƿ˽
        boolean fisontop = content.getBooleanValue("fisontop");//Ƿö
        Date fbegdate = content.getDate("fbegdate");//ʼʱ
        Date fenddate = content.getDate("fenddate");//ʱ

        PaoSetRemote tnoticeSet = getP2ServerSystemPaoSet("tnotice", "siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "'");
        PaoRemote tnotice = null;
        if (tnoticeid <= 0 || tnoticeSet.isEmpty()) {
            tnotice = tnoticeSet.addAtEnd();
            tnotice.setValue("siteid", siteid, 11L);//ҵID
            tnotice.setValue("createby", username, 11L);//¼
            tnotice.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tnotice = tnoticeSet.getPao(0);
        }
        tnotice.setValue("ftype", ftype, 11L);//
        tnotice.setValue("ftitle", ftitle, 11L);//
        tnotice.setValue("fsummary", fsummary, 11L);//
        tnotice.setValue("fcontent", fcontent, 11L);//
        tnotice.setValue("fissecret", fissecret, 11L);//Ƿ˽
        tnotice.setValue("fisontop", fisontop, 11L);//Ƿö
        tnotice.setValue("fbegdate", fbegdate, 11L);//ʼʱ
        tnotice.setValue("fenddate", fenddate, 11L);//ʱ
        tnotice.setValue("changeby", username, 11L);//޸
        tnotice.setValue("changedate", sysdate, 11L);//޸ʱ
        content.put("tnoticeid", tnotice.getUniqueIDValue());
        saveDataLog(tnotice);
        tnoticeSet.save();
        return query_noticeMain();
    }

    /**
     * 
     *
     * @return
     */
    public String check() {
        String tnoticeid = content.getString("tnoticeid");
        boolean fischeck = content.getBooleanValue("fischeck");//Ƿ񷢲
        SQLFactory sqlFactory = null;
        if (fischeck) {
            sqlFactory = new SQLFactory(this, "淢");
            sqlFactory.addParameter("checkby", username);
        } else {
            sqlFactory = new SQLFactory(this, "ȡ");
        }
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ɾ
     *
     * @return
     */
    public String delete() {
        long tnoticeid = content.getLongValue("tnoticeid");
        if (dbConnect.runSqlQuery("select * from tnotice where siteid='" + siteid + "' and fstatus='½' and tnoticeid=" + tnoticeid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * ѯԱ
     *
     * @return
     */
    public String query_noticeuserList() {
        String tnoticeid = content.getString("tnoticeid");
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("t3.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fusertype") && !"".equals(whereObject.getString("fusertype"))) {
                where.append(" and(");
                where.append("t2.fusertype ='").append(whereObject.getString("fusertype")).append("' ");
                where.append(")");
            }
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ѯԱ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ӹԱ
     *
     * @return
     */
    public String adduser() {
        String tnoticeid = content.getString("tnoticeid");
        JSONArray idarray = content.getJSONArray("tenterprise_userid");
        Iterator<Object> it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ӹԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tenterprise_userid", (String) it.next());
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡԱ").toString();
    }

    /**
     * ӹԱ
     *
     * @return
     */
    public String addusergroup() {
        String tnoticeid = content.getString("tnoticeid");
        long tusergroupid = content.getLongValue("tusergroupid");
        SQLFactory sqlFactory = null;
        if (tusergroupid == 1) {
            sqlFactory = new SQLFactory(this, "ӹԱ_ҵԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        } else if (tusergroupid == 2) {
            sqlFactory = new SQLFactory(this, "ӹԱ_о˺");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        } else if (tusergroupid == 3) {
            sqlFactory = new SQLFactory(this, "ӹԱ_оԱ˺");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        } else {
            sqlFactory = new SQLFactory(this, "ӹԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);

        }
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ɾᱨԱ
     *
     * @return
     */
    public String deleteuser() {
        String tnoticeid = content.getString("tnoticeid");
        JSONArray idarray = content.getJSONArray("tenterprise_userid");
        Iterator<Object> it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ɾԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tenterprise_userid", (String) it.next());
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡɾԱ").toString();
    }

    /**
     * 
     *
     * @return
     */
    public String analysis() {
        String sort = content.getString("sort");
        if ("־ֵ".equals(sort)) {
            sort = "AVG(t3.fscore) desc";
        } else if ("".equals(sort)) {
            sort = "count(distinct t2.tenterprise_userid) desc";
        } else if ("".equals(sort)) {
            sort = "t4.fdownloadcount desc";
        } else if ("".equals(sort)) {
            sort = "count(distinct t3.tenterprise_userid) desc";
        } else if ("".equals(sort)) {
            sort = "count(distinct t3.tenterprise_userid)/case when count(distinct t2.tenterprise_userid)=0 then 1 else count(distinct t2.tenterprise_userid) end desc";
        } else {
            sort = "count(distinct t2.tenterprise_userid) desc";
        }
        String where = " 1=1 ";
        String ftype = content.getString("ftype");
        if (!"".equals(ftype) && !"ȫ".equals(ftype)) {
            where = where + " and t1.ftype='" + ftype + "'";
        }
        String ftime = content.getString("ftime");
        if ("".equals(ftime)) {
            where = where + " and DATEPART(YEAR,t1.checkdate)=DATEPART(YEAR,getdate()) ";
        } else if ("".equals(ftime)) {
            where = where + " and DATEPART(QUARTER,t1.checkdate)=DATEPART(QUARTER,getdate()) ";
        } else if ("".equals(ftime)) {
            where = where + " and DATEPART(MONTH,t1.checkdate)=DATEPART(MONTH,getdate()) ";
        } else if ("".equals(ftime)) {
            where = where + " and DATEPART(WEEK,t1.checkdate)=DATEPART(WEEK,getdate()) ";
        }

        SQLFactory factory = new SQLFactory(this, "_", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * Ķ
     *
     * @return
     */
    public String read_analysis() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_澭Ķռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ķ
     *
     * @return
     */
    public String read_analysis_saler() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_ҵԱĶռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ط
     *
     * @return
     */
    public String download_analysis() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_澭ռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ط
     *
     * @return
     */
    public String download_analysis_saler() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_ҵԱռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ַ
     *
     * @return
     */
    public String score_analysis() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_澭ַ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ַ
     *
     * @return
     */
    public String score_analysis_saler() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_ҵԱַ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * 
     *
     * @return
     */
    public String scorelist_analysis() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_б_", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * 
     *
     * @return
     */
    public String scorelist_analysis_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_б_ҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_δ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_δҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");

        SQLFactory factory = new SQLFactory(this, "_", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tnotice' and t1.ownerid='" + tnoticeid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");

        SQLFactory factory = new SQLFactory(this, "_ҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());

        Rows downloaduserid = dbConnect.runSqlQuery("select t2.tenterprise_userid from tattachment t1 inner join tattachment_downlog t2 on t1.siteid=t2.siteid and t1.tattachmentid=t2.tattachmentid where  t1.siteid='" + siteid + "' and t1.ownertable='tnotice' and t1.ownerid='" + tnoticeid + "' ");
        ArrayList<String> userlist = downloaduserid.toArrayList("tenterprise_userid");
        for (Row row : rows) {
            row.put("fisdownloadfile", userlist.contains(row.getString("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_δؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δûб
     *
     * @return
     */
    public String havenodownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_δҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");

        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_ؾ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ûб
     *
     * @return
     */
    public String havedownloaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");

        String tnoticeid = content.getString("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "_ҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
