package com.cnd3b.restcontroller.enterprise.webclient.submitedit;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;

/**
 * ᱨ
 */
public class submitedit extends Controller {

    public submitedit(JSONObject content) {
        super(content);
    }

    /**
     * ½޸ᱨģ
     */
    public String insertOrModify() throws D3bException, P2Exception {
        long tsubmiteditmodelid = content.getLong("tsubmiteditmodelid"); //ʱĬϴ0
        String ftitle = content.getString("ftitle", "tsubmiteditmodel.ftitle", "");//
        Date fbegdate = content.getDate("fbegdate");//ʼʱ
        Date fenddate = content.getDate("fenddate");//ʱ
        String fnotes = content.getString("fnotes", "tsubmiteditmodel.fnotes", "ᱨҪ");//ᱨҪ
        boolean fisattrequired = content.getBooleanValue("fisattrequired");//
        boolean fistextrequired = content.getBooleanValue("fistextrequired");//ֱ
        boolean fisnotlimittimes = content.getBooleanValue("fisnotlimittimes");//Ƿһ¶౨

        PaoSetRemote tsubmiteditmodelSet = getP2ServerSystemPaoSet("tsubmiteditmodel", "siteid='" + siteid + "' and tsubmiteditmodelid='" + tsubmiteditmodelid + "'");
        PaoRemote tsubmiteditmodel = null;
        if (tsubmiteditmodelid <= 0 || tsubmiteditmodelSet.isEmpty()) {
            tsubmiteditmodel = tsubmiteditmodelSet.addAtEnd();
            tsubmiteditmodel.setValue("siteid", siteid, 11L);//ҵID
            tsubmiteditmodel.setValue("createby", username, 11L);//¼
            tsubmiteditmodel.setValue("createdate", sysdate, 11L);//¼ʱ
            tsubmiteditmodel.setValue("fstatus", "½", 11L);
        } else {
            tsubmiteditmodel = tsubmiteditmodelSet.getPao(0);
        }
        tsubmiteditmodel.setValue("fisnotlimittimes", fisnotlimittimes, 11L);//Ƿһ¶౨
        tsubmiteditmodel.setValue("ftitle", ftitle, 11L);//
        tsubmiteditmodel.setValue("fbegdate", fbegdate, 11L);//ʼʱ
        tsubmiteditmodel.setValue("fenddate", fenddate, 11L);//ʱ
        tsubmiteditmodel.setValue("fnotes", fnotes, 11L);//ᱨҪ
        tsubmiteditmodel.setValue("fisattrequired", fisattrequired, 11L);//
        tsubmiteditmodel.setValue("fistextrequired", fistextrequired, 11L);//ֱ
        tsubmiteditmodel.setValue("changeby", username, 11L);//޸
        tsubmiteditmodel.setValue("changedate", sysdate, 11L);//޸ʱ

        content.put("tsubmiteditmodelid", tsubmiteditmodel.getUniqueIDValue());
        saveDataLog(tsubmiteditmodel);
        tsubmiteditmodelSet.save();

        return query_submitEditMain();
    }

    public String query_submitEditMain() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory noticehead = new SQLFactory(this, "ᱨѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ᱨģ巢
     */
    public String check() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        boolean fischeck = content.getBooleanValue("fischeck");//Ƿ񷢲
        SQLFactory sqlFactory = null;
        if (fischeck) {
            sqlFactory = new SQLFactory(this, "ᱨģ巢");
            sqlFactory.addParameter("checkby", username);
        } else {
            sqlFactory = new SQLFactory(this, "ᱨģȡ");
        }
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }


    /**
     * ᱨбѯ
     *
     * @return
     */
    public String query_submiteditmodelList() {
        /**
         *
         */
        String[] sortfield = {"t1.checkdate"};
        String sort = getSort(sortfield, "t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fisnotlimittimes") && !"".equals(whereObject.getString("fisnotlimittimes"))) {
                where.append(" and(");
                where.append("t1.fisnotlimittimes ='").append(whereObject.getString("fisnotlimittimes")).append("' ");
                where.append(")");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ᱨбѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ᱨϸѯ
     *
     * @return
     */
    public String query_submiteditList() {
        /**
         *
         */
        String[] sortfield = {"t1.submitdate"};
        String sort = getSort(sortfield, "t1.submitdate desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.createby like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t3.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("tenterprise_userid") && !"".equals(whereObject.getString("tenterprise_userid"))) {
                where.append(" and(");
                where.append("t1.tenterprise_userid ='").append(whereObject.getString("tenterprise_userid")).append("' ");
                where.append(")");
            }
        }
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");//ᱨģID
        SQLFactory costhead = new SQLFactory(this, "ᱨϸбѯ", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        costhead.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ᱨ˻
     *
     * @return
     */
    public String returnedit() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");//ᱨģID
        long tsubmiteditid = content.getLongValue("tsubmiteditid");

        SQLFactory sqlFactory = new SQLFactory(this, "ᱨ˻");
        sqlFactory.addParameter("returnby", username);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        sqlFactory.addParameter("tsubmiteditid", tsubmiteditid);

        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }


    /**
     * ᱨģɾ
     *
     * @return
     */
    public String delete() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");//ᱨģID
        if (dbConnect.runSqlQuery("select * from tsubmiteditmodel where siteid='" + siteid + "' and fstatus='½' and tsubmiteditmodelid=" + tsubmiteditmodelid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ!").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ᱨģɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tsubmiteditmodelid", content.getString("tsubmiteditmodelid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ѯᱨԱ
     *
     * @return
     */
    public String query_submitedituserList() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        /**
         *
         */
        String[] sortfield = {"t1.tsubmiteditid"};
        String sort = getSort(sortfield, "t1.tsubmiteditid");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("t3.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fusertype") && !"".equals(whereObject.getString("fusertype"))) {
                where.append(" and(");
                where.append("t2.fusertype ='").append(whereObject.getString("fusertype")).append("' ");
                where.append(")");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ѯᱨԱ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ᱨԱ
     *
     * @return
     */
    public String adduser() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        JSONArray idarray = content.getJSONArray("tenterprise_userid");
        Iterator it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ᱨԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
            sqlFactory.addParameter("tenterprise_userid", (String) it.next());
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡԱ!").toString();
    }

    /**
     * ᱨԱ
     *
     * @return
     */
    public String addusergroup() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        long tusergroupid = content.getLongValue("tusergroupid");

        SQLFactory sqlFactory = null;
        if (tusergroupid == 1) {
            sqlFactory = new SQLFactory(this, "ᱨԱ_ҵԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        } else if (tusergroupid == 2) {
            sqlFactory = new SQLFactory(this, "ᱨԱ_о˺");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        } else {
            sqlFactory = new SQLFactory(this, "ᱨԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
            sqlFactory.addParameter("tusergroupid", tusergroupid);
        }
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ɾᱨԱ
     *
     * @return
     */
    public String deleteuser() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        JSONArray idarray = content.getJSONArray("tenterprise_userid");
        Iterator<Object> it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ɾᱨԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
            sqlFactory.addParameter("tenterprise_userid", (String) it.next());
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡɾԱ!").toString();
    }


    /**
     * δᱨûб
     *
     * @return
     */
    public String havenoreaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tsubmiteditid"};
        String sort = getSort(sortfield, "t1.tsubmiteditid");
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory factory = new SQLFactory(this, "_δᱨ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * δᱨûб
     *
     * @return
     */
    public String havenoreaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tsubmiteditid"};
        String sort = getSort(sortfield, "t1.tsubmiteditid");
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory factory = new SQLFactory(this, "_δᱨҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ᱨûб
     *
     * @return
     */
    public String havereaduserlist() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory factory = new SQLFactory(this, "_ᱨ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ᱨûб
     *
     * @return
     */
    public String havereaduserlist_saler() {
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory factory = new SQLFactory(this, "_ᱨҵԱ", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ᱨ
     *
     * @return
     */
    public String submit_analysis() {
        long tsubmiteditmodelid = content.getLongValue("tsubmiteditmodelid");
        SQLFactory factory = new SQLFactory(this, "_ᱨռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tsubmiteditmodelid", tsubmiteditmodelid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }
}
