package com.cnd3b.restcontroller.singleagent.webclient.data;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import com.cnd3b.restcontroller.enterprise.agentclient.mainpage.data.DataTips;

import java.text.SimpleDateFormat;
import java.util.Calendar;

public class analysis extends Controller {
    public analysis(JSONObject content) {
        super(content);
    }

    /**
     * ҳ
     *
     * @return
     */
    public String query_briefreport() {

        String fbegdate = content.getString("fbegdate");
        String fenddate = content.getString("fenddate");

        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory factory = new SQLFactory(this, "ͳƿ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tagentsid", tagentsid);
        factory.addParameter("fbegdate", fbegdate);
        factory.addParameter("fenddate", fenddate);
        factory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows.get(0)).saveToDataPool(1).toString();
    }

    /**
     * ɽƷ״ͼ
     *
     * @return ѯ
     */
    public String productoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t2.tenterprise_userid is null or t2.tenterprise_userid='").append(userid).append("' or t2.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ɽƷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "ɽƷ").getTips()).saveToDataPool().toString();
    }

    /**
     * ͵ֵͼ
     *
     * @return ѯ
     */
    public String amountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }
        SQLFactory sqlFactory = new SQLFactory(this, "͵ֵ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "͵ֵ").getTips()).saveToDataPool().toString();
    }


    /**
     * Сռȷͼ
     *
     * @return ѯ
     */
    public String communityoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory sqlFactory = new SQLFactory(this, "Сռȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "Сռȷ").getTips()).saveToDataPool().toString();
    }

    /**
     * Сȷ
     *
     * @return ѯ
     */
    public String communitydepthoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory sqlFactory = new SQLFactory(this, "Сȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "Сȷ").getTips()).saveToDataPool().toString();
    }

    /**
     * ˵ʷͼ
     *
     * @return ѯ
     */
    public String returncountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory sqlFactory = new SQLFactory(this, "˵ʷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).setTips(new DataTips(rows, "˵ʷ").getTips()).saveToDataPool().toString();
    }


    /**
     * Ͽͻ
     *
     * @return
     */
    public String oldcustomer() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t1.tenterprise_userid is null or t1.tenterprise_userid='").append(userid).append("' or t1.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ϿͻϢ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter("pageNumber", pageNumber);
        sqlFactory.addParameter("pageSize", pageSize);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("pageNumber", pageNumber);
        returnObject.put("pageSize", pageSize);
        returnObject.put("total", rows.getTotalRows());
        returnObject.put("pageTotal", rows.getTotalPage());
        returnObject.put("tips", new DataTips(rows, "ϿͻϢ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public String oldcustomerbless() {
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t2.tenterprise_userid is null or t2.tenterprise_userid='").append(userid).append("' or t2.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        //Ϊ0Ĭȡǰǰ12µ
        SQLFactory sqlFactory = new SQLFactory(this, "Ͽͻάϵͳ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("tips", new DataTips(rows, "Ͽͻάϵͳ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public String oldcustomercycle() {
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (!fisadministrator) {
            where.append(" and (t2.tenterprise_userid is null or t2.tenterprise_userid='").append(userid).append("' or t2.tenterprise_userid in ( select fsubid from tenterprise_userdetail where siteid='").append(siteid).append("' and fparentid='").append(userid).append("' )) ");
        }

        //Ϊ0Ĭȡǰǰ12µ
        SQLFactory sqlFactory = new SQLFactory(this, "Ͽͻάϵͳ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("tips", new DataTips(rows, "Ͽͻάϵͳ").getTips());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }


}
